// FILENAME: fairplay
//
// by Dangerfreak
//------------------------------------------------------------------------------
$version = "1.4";
$missionName = "Dangerfreak";
exec("multiplayerStdLib.cs");
exec("DMstdLib.cs");
exec("DF_RemoteLib.cs");

function setDefaultMissionItems()
{
	allowComponent(all,True);
	noCheapWeapons();
}

function setDefaultMissionOptions()
{
	$server::TeamPlay = True;
	$server::AllowDeathmatch = True;
	$server::AllowTeamPlay = False;	
	
	$server::AllowTeamRed = true;
	$server::AllowTeamBlue = true;
	$server::AllowTeamYellow = true;
	$server::AllowTeamPurple = true;

   $server::disableTeamRed = false;
   $server::disableTeamBlue = false;
   $server::disableTeamYellow = false;
   $server::disableTeamPurple = false;
}

function player::onAdd(%this)                                                            
{
 %ausgabe = "This is a recruiting/training server.\n"
          @ "If you want to stay please check the game info tab!!!\n"
	  @ $copyright;
 say(%this,0,%ausgabe);
 messagebox(%this,"PLEASE CHECK GAME INFO TAB FIRST!");
 antistealth(%this,"in");
}

function vehicle::onAdd(%vehicleId)
{
  %vehicleId.ziel = 0;
  %vehicleId.nziel = 0;
  %vehicleId.timeout = 0;
  %vehicleId.timer = 0;
}

function vehicle::onDestroyed(%destroyed,%destroyer)
{
	%player = playerManager::vehicleIdToPlayerNum(%destroyed);
	if (%player >0)
	{
		say(0,1,getHudName(%destroyer) @ " killed " @ getHudName(%destroyed));
		fullheal(%destroyer);
		%time = getCurrentTime();
		%destroyer.timeout = %time;
		%destroyed.timeout = %time; 
		if (%destroyer.ziel == %destroyed)
		{
			%destroyer.ziel = 0;
		}
		%destroyed.ziel = 0;
		%destroyer.nziel = 0;
		%destroyed.timer = 0;
		%destroyer.timer = 0;
	}
}

function onMissionLoad()
{
   cdAudioCycle("Purge"); 
   $server::TeamDamage = true;
   %ausgabe1 = "Welcome! (script version " @ $version @ ")\n"
            @ "This is a recruiting/training server.\n\n"
            @ "FAIRNESS is our rule number one! That means:\n"
            @ "1) Fight ONE-ON-ONE!\n"
            @ "2) No teaming!\n"
            @ "3) No padkilling (except during a fight).\n"
            @ "4) Don't start a fight shooting in your opponent's back.\n"
            @ "5) Let your opponent heal, reload and recharge before starting a fight.\n"
            @ "6) Don't use cheap weapons (sguns, plasma, missiles, also rads and hbc's).\n"
            @ "7) Always be polite/don't offend anyone (ironical comments are strictly ALLOWED)!\n";
   %ausgabe2 = "NOTES:\n"
            @ "- An attacker will automatically be destroyed, if...\n"
            @ "  ...he and his opponent didn't scan each other before.\n"
            @ "  ...he tries to team or disturb a duel.\n"
            @ "\n"
            @ "Have fun!\n" @ $copyright;   
   setGameInfo(%ausgabe1 @ %ausgabe2);
}

// Easter Egg time
function AirChina::trigger::onEnter(%this, %vehicleId)
{
	say(playerManager::vehicleIdToPlayerNum(%vehicleId), 0, *IDMULT_AIR_CHINA);
	%backToTheField = strcat("endTheTrip(", %vehicleId, ");");
	schedule(%backToTheField, 10);	
}

function endTheTrip(%vehicleId)
{
	randomTransport(%vehicleId, -1890, 1681, -1890, 1681);
}

function vehicle::onAttacked(%attacked,%attacker)
{
	if ((%attacker.ziel != %attacked || %attacked.ziel != %attacker) || (%attacker.ziel == %attacked && %attacked.ziel == %attacker && %attacker.timer+3>getCurrentTime()))
	{
		%a = playerManager::vehicleIdToPlayerNum(%attacked);
		%p = playerManager::vehicleIdToPlayerNum(%attacker);
		if ( %a > 0 && %p > 0 && %a != %p && (%attacker.timeout + 1 < getCurrentTime() ))
		{
			healObject(%attacker,-50000);
			%attacker.timeout = getCurrentTime();
			%a = getHudName(%attacker);
			%p = getHudName(%attacked);
			say(0,1,%a @ " started firing at " @ %p @ ", but has been destroyed because " @ %p @ " wasn't ready or had another fight");
			%player = playerManager::vehicleIdToPlayerNum(%attacker);
			messagebox(%player,"Your opponent wasn't ready or you teamed! Stop that!");
		}
	}
}

function vehicle::onScan(%scanned,%scanner)
{
	%a = getHudName(%scanner);
        %p = getHudName(%scanned);
	%player = playerManager::vehicleIdToPlayerNum(%scanner);	
	if (%scanned == %scanner.ziel)    // ist target bereits ziel?
	{
		say(%player,1,"Your fight already started!");
	}
	else
	{
		if (%scanned.ziel !=0 && %scanned.ziel != %scanner)
		{
			say(%player,1,"This target has another fight already!");
		}	
		else
		{
			if (%scanner.nziel == %scanned)   // ist target schon gescannt?
			{
				say(%player,1,"This is already your target, wait for response!");
			}
			else
			{
				if (%scanned.nziel != %scanner) // hat p schon a gescannt? 
				{
					say(0,1,%a @ " wants to fight against " @ %p);
					%scanner.nziel = %scanned;
					schedule("lost(" @ %scanner @ "," @ %scanned @ ");",10);
				}
				else
				{
					
					say(0,1,%a @ " vs. " @ %p @ "! Start fighting when timer is zero!");
					%scanner.ziel = %scanned;
					%scanned.ziel = %scanner;
					%scanner.timer = getCurrentTime();
					%scanned.timer = %scanner.timer;
					setHudTimer(3,down,"START FIGHTING WHEN TIMER IS ZERO",1,%player);
					%player = playerManager::vehicleIdToPlayerNum(%scanned);
					setHudTimer(3,down,"START FIGHTING WHEN TIMER IS ZERO",1,%player);
					%scanner.nziel = 0;
					%scanned.nziel = 0;
				}
			}
		}
	}
}

function lost(%scanner,%scanned)
{
	if (%scanner.nziel == %scanned)
	{
		say(0,1,getHudName(%scanner) @ " lost his target... Scan again!");
		%scanner.nziel = 0;
	}
}

