// Skilltest by Dangerfreak
//------------------------------------------------------------------------------

$missionName = "Skill Test V1.2";
clear();

exec("multiplayerStdLib.cs");
exec("DMstdLib.cs");
exec("DF_RemoteLib.cs");

function setDefaultMissionItems()
{
	allowComponent(all, TRUE);
	allowComponent(845,FALSE); // scap
	allowComponent(840,FALSE); // smod
	allowComponent(890,FALSE); // repair
	allowComponent(910,FALSE); // agrav
	allowComponent(830,FALSE); // cloak
	allowComponent(831,FALSE); // cloak
	noCheapWeapons();
}

function setDefaultMissionOptions()
{
	$server::TeamPlay = true;
	$server::AllowDeathmatch = true;
	$server::AllowTeamPlay = true;	

   // what can the client choose for a team
	$server::AllowTeamRed = true;
	$server::AllowTeamBlue = false;
	$server::AllowTeamYellow = true;
	$server::AllowTeamPurple = false;
      
   // what can the server admin choose for available teams
   $server::disableTeamRed = false;
   $server::disableTeamBlue = true;
   $server::disableTeamYellow = false;
   $server::disableTeamPurple = true;
   
}

function onMissionStart()
{
        // marsSounds();
}

function onMissionLoad(){
   cdAudioCycle("Gnash"); 
   %text = $missionName @ "\n\n" @
	   "This is a skilltest map, the player who wants check his fighting skill has" @
 	   "to host the server in order to have a good ping. " @
	   "He must choose the red team, all other players yellow. " @
	   "ALL WATCHERS MUST USE A SEEKER OR A BOLO WITHOUT WEAPONS, " @
	   "CARBON ARMOR, ECM AND THERMAL DIFFUSER AND SWITCH THEIR " @
	   "RADAR TO PASSIVE!!!\n" @
           "Watchers mustn't disturb or help the player in any way!!!\n\n" @
           "Enemies with different skills will come one after one " @
           "to test the player's skill. His fighting grade depends on " @
           "the number of kills.\n" @ $copyright;
   setGameInfo(%text);
}

function player::onAdd(%this)
{
	antistealth(%this,"in");
	messagebox(%this,"Check the game info tab first!");
}

function player::onRemove(%player)
{
	antistealth(%player,"out");
	%vehicleId = playerManager::playerNumToVehicleId(%player);
	if (getTeam(%vehicleId) == *IDSTR_TEAM_RED)
	{
		clear();
	}
}

function vehicle::onAdd(%this)
{
	%player = playerManager::vehicleIdtoPlayerNum(%this);
	if (%player != 0)
	{
		if (getTeam(%this) == *IDSTR_TEAM_RED)
		{
			if ($redcount == 0)
			{
				$redcount = 1;
				$redveh = %this;
				$irq = 1;
				schedule("interrupt();",11);
			}
			else
			{
				setTeam(%this,*IDSTR_TEAM_YELLOW);
				messagebox(%player,"Another player is red already!");
			}
		}
		if (getTeam(%this) == *IDSTR_TEAM_YELLOW)
		{
			%name=getvehiclename(%this);
			if ((%name != "Bolo" && %name !="Seeker") || getWeaponCount(%this)>0 )
			{
				messagebox(%player,"Take unarmed Bolo or Seeker only!");
				schedule("healobject(" @ %this @ ",-50000);",3);
			}
		}
	}
}

function vehicle::onDestroyed(%destroyed,%destroyer)
{
	say(0,1,getHudName(%destroyer) @ " destroyed " @ getHudName(%destroyed));
	if (getTeam(%destroyed) == *IDSTR_TEAM_YELLOW)
	{
		%player = playerManager::vehicleIdToPlayerNum(%destroyed);
		if (%player == 0)
		{
			schedule("deleteObject(" @ %destroyed @ ");",10);
			$enemies = 0;
			$killed++;
			say(0,1,getHudName(%destroyer) @ "'s score so far: " @ $killed);
			reloadObject(%destroyer,10000);
			// healObject(%destroyer,10000);
		}
		else
		{
			say(0,1,"No score!");
		}
	}
	else
	{
		say(0,1,"Pilot killed " @ $killed @ " enemies.");
		clear();
	}
}

function vehicle::onAttacked(%attacked,%attacker)
{
	%player = playerManager::vehicleIdtoPlayerNum(%attacker);
	if (%player != 0)
	{
		if (getTeam(%attacker) != *IDSTR_TEAM_RED)
		{
			if (%attacked != %attacker)
			{
				healobject(%attacker,-50000);
				messagebox(%player,"Don't disturb the skill test! Read game info!");
			}
		}
	}
}

function interrupt()
{
	if ($irq == 1)
	{
		if ($enemies == 0)
		{
			makeAI();
			$enemies = 1;
		}
		schedule("interrupt();",5);
	}
}

function makeAI()
{
	$r++;
	if ($r > 7)
	{
		$r = 1;
	}	
	if ($r == 6) 
	{
		%veh = 8236;
		%obj = "Exec mfac emp";
	}
	if ($r == 4) 
	{
		%veh = 8230; 
		%obj = "Gorg pbw emp";
	}
	if ($r == 5)
	{
		%veh = 8221;
		%obj = "Oly rail emp";
	}
	if ($r == 3)
	{
		%veh = 8242; 
		%obj = "Apoc rail emc emp";
	}
	if ($r == 2)
	{
		%veh = 8250;
		%obj = "Apoc nanit emp";
	}
	if ($r == 1)
	{
		%veh = 8258;
		%obj = "Goad elf";
	}
	if ($r == 7)
	{
		%veh = 8262;
		%obj = "Myr mfac";
	}
	%herc = cloneVehicle(%veh);
	%dist = 0;
	for (%p=0; %dist<1500; %p++)
	{
		%x = randomInt(-1500,1500);
		%y = randomInt(-1500,2000);
		%z = getPosition($redveh,x);
		if (%z > %x)
		{
			%dist = %z - %x;
		}
		else
		{
			%dist = %x -%z;
		}
		%z = getPosition($redveh,y);
		if (%z > %y)
		{
			%dist = %dist + %z - %y;
		}
		else
		{
			%dist = %dist + %x - %z;
		}
	} 
	%z = 270;
	setPosition(%herc,%x,%y,%z);
	order(%herc,attack,$redveh);
	say(0,1,"Enemy created, " @ %obj);
	$lastenemy = %herc;
}

function reset::structure::onAttacked(%attacked,%attacker) 
{
	say(0,1,"Game Reset!");
	if ($redveh != 0)
	{
		healobject($redveh,-50000);
	}
	clear();
}

function clear()
{
	if ($lastenemy != 0)
	{
		deleteobject($lastenemy);
	}
	$irq = 0;
	$enemies = 0;
	$killed = 0;
	$redveh = 0;
	$redcount =0;
	$lastenemy = 0;
	$r = 0;
}
