// FILENAME:	Mars_Base.cs
//
// AUTHORS:  	Some1 and pD!
//
// COMMENTS:    (After landing in the Fire Pit) Boy is it hot in here or what?
//------------------------------------------------------------------------------

$missionName = "Mars_Base";

exec("multiplayerStdLib.cs");
exec("DMstdLib.cs");

function setDefaultMissionOptions()
{
	$server::TeamPlay = false;
	$server::AllowDeathmatch = true;
	$server::AllowTeamPlay = true;	
	
	$server::AllowTeamRed = true;
	$server::AllowTeamBlue = true;
	$server::AllowTeamYellow = false;
	$server::AllowTeamPurple = false;
}

function onMissionLoad(){
   cdAudioCycle("newtech", "yougot"); 
}

function onMissionStart()
{
	$healRate = 100;   
	$ammoRate = 3;
   	$padWaitTime = 45;
  	$zenWaitTime = 90;

	marsSounds();	
        alarmSoundsOn();
}
function player::onAdd(%this)
{
  say(%this, 0, "<f3>Welcome to Mars Base!  Cybrids have unleashed a radiation bomb, but we have put up barriers sheilding us form it.  Do not exit the barriers or else you will 'slode.  The Cybrids have a force ready to attack us so we are boarding a Ship to the Fire Kitchen, a place of intense heat.  There is a mine field be careful.  Map made by [GoP]~SoMeOnE~TL.");
}

// The Base Barriers Commands.
//------------------------------------------------------------------------------
function boom::trigger::onEnter(%trigger, %vehicleId)
{
   healObject(%vehicleId, -500000);
}

// Transport to the Space Ship.
//------------------------------------------------------------------------------
function dstr::trigger::onEnter(%trigger, %vehicleId)
{
   setPosition(%vehicleId, 469.7, -7441.7, 117.8);
}

// From the Space Ship to the Fire Kitchen.
//------------------------------------------------------------------------------
function fkit::trigger::onEnter(%trigger, %vehicleId)
{
   setPosition(%vehicleId, -359.2, 7240.1, 100.1);
}

// Mines.
//------------------------------------------------------------------------------
function mine::trigger::onEnter(%trigger, %vehicleId)
{
     healObject(%vehicleId, -50000);
}

// Warning... who needs them?
//------------------------------------------------------------------------------
function warn::trigger::onEnter(%trigger, %vehicleId)
{
   %player = playerManager::vehicleIdToPlayerNum(%vehicleId);
   messageBox(%player, "WARNING: Mine Field detected!");
}


// Seeker Sity
//------------------------------------------------------------------------------
function seek::structure::onScan(%scanned, %scanner)
{
   setPosition(%scanner, 160.4, -8410.5, 101.8);
}

// Transport to Home Base from Fire Kitchen.
//------------------------------------------------------------------------------
function home::trigger::onEnter(%trigger, %vehicleId)
{
   setPosition(%vehicleId, -138.9, 247.3, 99);
}

// Healing Pad Functionality
//------------------------------------------------------------------------------
function ZenHeal::trigger::onEnter(%this, %object)
{
   	Zen::onEnter(%this, %object, *IDMULT_CHAT_HEALPAD, true, true);  
}
function ZenHeal::trigger::onContact(%this, %object)
{
   	Zen::work(%this, %object, $healRate, 0, $padWaitTime, true); 
}

// Ammo Pad Functionality
//------------------------------------------------------------------------------
function ZenAmmo::trigger::onEnter(%this, %object)
{
   	Zen::onEnter(%this, %object, *IDMULT_CHAT_AMMOPAD, true, true);  
}

function ZenAmmo::trigger::onContact(%this, %object)
{
   	Zen::work(%this, %object, 0, $ammoRate, $padWaitTime, true); 
}

// ZenAll Pad Functionality
//------------------------------------------------------------------------------
function ZenAll::trigger::onEnter(%this, %object)
{
   	Zen::onEnter(%this, %object, *IDMULT_CHAT_ALLPAD, true, true);  
}
function ZenAll::trigger::onContact(%this, %object)
{
   	Zen::work(%this, %object, $healRate, $ammoRate, $padWaitTime, true); 
}