// mkSiddhartha.cs
// An objlib script to build DM_/CTF_Siddhartha.

exec("objlib.cs");

objsetverbosity(0);

// Set to 1 to make a CTF mission, 0 for DM/TDM
$ctf = 1;

// A path marker called Origin is the only object created by hand,
// it defines center around which everything else is positioned.
$x = getPosition("MissionGroup/Origin",x);
$y = getPosition("MissionGroup/Origin",y);
$z = -10000; // -10000 means object z is relative to terrain height
$radius = 500;

function Base(%t,%x,%y,%z,%r) {
	objsetteam(%t);
	objsetorigin(%x,%y,%z,%r);
	%color = objgetteamcolor();
	%id = objsimshapegroup(0,objgetteambase());

	lobj(%id,"NavPoint","ESNavMarker_Nav"@%color,"",0,-145,-1,0);

	if ($ctf && ((%t==2) || (%t==4))) {
		// CTF flags and droppoints only for Blue and Purple teams
		lobj(%id,%color@"Flag","StaticShape_"@%color@"Flag","",0,-145,0,0);
		lobj(%id,%color@"FlagTrigger","SimTrigger_"@%color@"Flag","",0,-145,5,0);
		%dpgid = objdpgroup();
		//objdpbox(%dpgid,4,3,30,30,0,-240,0,0);
		objdpline(%dpgid,12,30,0,-240,0,0);
	}

	lobj(%id,"HealTrigger","SimTrigger_"@%color@"Heal","",-80,-110,0,0);
	lobj(%id,"AmmoTrigger","SimTrigger_"@%color@"Ammo","", 80,-110,0,0);
	nobj(%id,"HealPad",StaticInterior,"hHeallite.dis",-80,-110,0,0);
	nobj(%id,"AmmoPad",StaticInterior,"hAmmolite.dis", 80,-110,0,0);
	//lobj(%id,"HealGen","StaticShape_"@%color@"HealGenLite","",-68,-237,-1,315);
	//lobj(%id,"AmmoGen","StaticShape_"@%color@"AmmoGenLite","", 68,-237,-1,225);

	nobj(%id,"LFWall",StaticInterior,"hwallhuge.dis",-85,-105,0,270);
	//nobj(%id,"LFTurret",Turret,1,-105,-85,0,270);
	nobj(%id,"RFWall",StaticInterior,"hwallhuge.dis", 85,-105,0,180);
	//nobj(%id,"RFTurret",Turret,1,105,-85,0,180);

	nobj(%id,"B1",StaticInterior,"hhugescraper1.dis",-320,-10,0,0);
	nobj(%id,"B2",StaticInterior,"hhugescraper2.dis",-170,50,0,90);
	nobj(%id,"MB2",StaticInterior,"hbigmars2m.dis",0,110,0,90);
	nobj(%id,"B8",StaticInterior,"hhugescraper8.dis",200,50,0,90);
	nobj(%id,"B4",StaticInterior,"hhugescraper4.dis",320,-10,0,0);

	nobj(%id,"B5",StaticInterior,"hhugescraper5.dis",-230,180,0,90);
	nobj(%id,"B7",StaticInterior,"hhugescraper7.dis",260,175,0,90);

	nobj(%id,"B6",StaticInterior,"hhugescraper6.dis",0,330,0,90);
	nobj(%id,"B3",StaticInterior,"hhugescraper3.dis",200,320,0,45);
}

objsetteam(0);
objsetorigin($x,$y,$z,0);

%id = objsimshapegroup(0,"CityCenter");
// must manually set Pedestal and Buddha to be Indestructible
nobj(%id,"Pedestal",StaticShape,"cRelay.dts",-1,-6,-60,0);
// also set Buddha Script Class to Buddha
nobj(%id,"Buddha",StaticShape,"hKongBuddha.dts",0,0,23,0);

if ($ctf) {
	Base(1,$x+$radius,$y,$z,90);
	Base(2,$x,$y-$radius,$z,0);
} else {
	// DM drop points
	%dpgid = objdpgroup();
	objdpcircle(%dpgid,12,$radius+240,0,0,0,0);

	Base(1,$x,$y-$radius,$z,0);
	Base(2,$x+$radius,$y,$z,90);
}
Base(3,$x-$radius,$y,$z,-90);
Base(4,$x,$y+$radius,$z,180);
