//Long Patrol 19
//
// Well, howdy fellow scripters.  This mission has some stuff in it which I think you 
// may find interesting.
//
// Firstly, the map itself is War - Martian Standoff, although it doesn't look like it.
//
// In the ME, I was able to change both the haze distance and the ambient lighting without
// affecting the ability of the players to join.  As a guideline, I used the numbers from
// some clearer maps, figuring that they would be well within the parameters of the game.
// The original map had a terrific terrain and sky, but nobody could see it.  The terrain
// was set to a steepness which was on the ragged edge of being herc-capable which made
// getting from point A to B a challenge as you had to pick a route. (Naturally, I stayed 
// away from the Terrain Editor and lighting sections, like a good boy.)
//
// Second, I wanted to make the map as random as possible so as to effectively have a 
// different mission each time it came up.  So the random elements are as follows.  One:
// Using Dolf's AI generator with a $baddies on/off switch, random small squads are 
// generated, numbers depending on the number of players.  Two:  The five squads attacking
// the five mines/navs are randomized to be composed of any one of five different herc
// types, so you never know what you are going to run into at any particular mine/nav.
// Three:  The first Nav is randomized so that each time the mission starts, the first Nav
// will be any one of the five available.  The rest will follow in an anticlockwise
// direction, so as to keep the distance to travel from being irritating.
// 
// Thirdly, (thirdly??, is that a word?) I stuck a $CurrentNav function in to allow
// those players joining while the game was in progress to know what nav was currently
// in use without having to ask.
//
// The convoys blow up taking the attacking squads with them, should you be lucky enough 
// to score a hit on the fuel truck without getting killed.  The mines blow up if you are 
// unlucky enough to blow the fuel truck near enough to trigger them, which counts against
// you, as you are supposed to be protecting the mines.
//
// Should you wound a Squad type AI, and he wanders off the map, he will self destruct at
// a specified distance, which allows the mission to continue, and which just goes to
// show how evil, nasty, and ruthless those in command of the Imperial Knights truly are.
//
// All in all, the mission plays well on the server, and the players seem happy.
//
//          Slade
//
//18 - oddly enough, some of the Dolf Generated AI are blowing up with the same
//     explosion as the fuel trucks.  I am speculating that the globals assigned
//     to the trucks are being assigned to the AI by a glitch.  No joy in removing
//     it.
//  
//19 - It only happens after all the mines have been visited so I will just add 
//     a TAC-COM statement warning of desperate suicide bombers.
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------




$OVconvoyTech = 2;

$server::TeamDamage = False;


$actionStarted = false;

$maxRange = 1750;
$minRange = 1500;

// how many player are alive at squad drop time
$numLivePlayers = 0;

//---------------------------
function setDefaultMissionOptions()
{
	$server::TeamPlay = true;
	$server::AllowDeathmatch = False;
	$server::AllowTeamPlay = true;	

   // what can the client choose for a team
	$server::AllowTeamRed = true;
	$server::AllowTeamBlue = False;
	$server::AllowTeamYellow = true;
	$server::AllowTeamPurple = False;

   // what can the server admin choose for available teams
   $server::disableTeamRed = False;
   $server::disableTeamBlue = true;
   $server::disableTeamYellow = False;
   $server::disableTeamPurple = true;

}
//----------------------------
Pilot AmmoPilot
{
   id = 28;
   
   skill = 0.5;
   accuracy = 0.5;
   aggressiveness = 0.8;
   activateDist = 8000.0;
   deactivateBuff =10000.0;
   targetFreq = 3.0;
   trackFreq = 1.0;
   fireFreq = 1.0;
   LOSFreq = 0.2;
   orderFreq = 1.5;
};

   
Pilot backupPilot
{
   id = 29;
   
   skill = 0.5;
   accuracy = 0.5;
   aggressiveness = 0.8;
   activateDist = 8000.0;
   deactivateBuff =10000.0;
   targetFreq = 3.0;
   trackFreq = 1.0;
   fireFreq = 1.0;
   LOSFreq = 0.2;
   orderFreq = 1.5;
};

Pilot PatrolPilot
{
   id = 30;
   name = "Knight";
   skill = 0.9;
   accuracy = 0.9;
   aggressiveness = 1.0;
   activateDist = 1000.0;
   deactivateBuff = 900.0;
   targetFreq = 2.0;
   trackFreq = 0.1;
   fireFreq = 0.5;
   LOSFreq = 0.2;
   orderFreq = 4.0;

};


//---------------------------------------------------------------------------
function onMissionLoad()
{


   cdAudioCycle("Purge", "Watching", "Mechsoul"); 

    $textMsg = "Mission Credits:  Slade .  \n\n"@
    "<F5>Objectives:   \n"@
    "1.  Defend the 5 mines against Imperial Patrols. \n"@
    "2.  Kill the Imp Patrols before they blow up our mines. \n"@
    "3.  Get back to the Dropship alive. \n\n"@
    "TAC-COM: Get to the Imps before they get to our stuff.  Good Luck.\n\n"@
   "<F3>Respawning is allowed. Destroying an enemy heals your vehicle and"@
   " reloads your weapons. Team Damage is off.";
   %history = 
"\n\nDate: 2829. Imperial Patrols are dropping in to destroy our mines.\n"@
" They are escorting explosives convoys.  If you can destroy their fuel truck \n"@
" it may take them with it.  If they reach the mines, they may attack the mining\n"@
" explosives shack.  If it goes, it will destroy everything within 400m. \n"@
"  Stop them before they get there. \n"@
" Our miners broke into several alien tunnels with odd weapons.  We think they know this. \n"@
" Don't screw this up.";



   setGameInfo ($textMsg @ %history);
}


//-----191------------------------------------------------------------------------
function onMissionStart()
{
   newFormation( Delta, 0,0,0, -60,-60,0, 60,-45,0, 0,-120,0 ); 
   newFormation( Line,  0,0,0, 0,-40,0, 0,-80,0, 0,-120,0 );

   cdAudioCycle( Purge, Terror, gnash);

   marsSounds();
   windSounds();
   init();

}

//---------------205------------------------------
function player::onAdd(%this)                                                                                                                        
{

say ( %this, 0, $Version @"\n"@ $textMsg );
say ( %this, 0,  "\nCheck the game info tab for more details");

}

//--------------------------------------------
function vehicle::onAdd(%this)                                                                                                                        
{


// see if it is a player, if not exit
   %player = playerManager::vehicleIdToPlayerNum(%this);

   if (%player == 0) 
      return;

// messagebox (%player, "Check the game info tab for game details");

//15*****************try this*********
  setNavMarker( $CurrentNav, true, %this  );

                                                                                   
   if (getTeam (%this) != *IDSTR_TEAM_YELLOW)
    {
     setTeam(%this, *IDSTR_TEAM_YELLOW);
     redrop(%this);


    }




//---------------------------
 if ( $actionStarted == true )
   {
    if ( %player.state == "tked" )  
        {
   	%player.state = "";
        }
      else
        {
////        schedule ("healObject(" @ %this @ ", -5000);", 3);

       }
   }

}

//-----------------Use to rotate Navpoints---------------------------------
function setfirstNavON()
{
    %firstNav = randomInt(1,5);

    if (%firstNav == 1)
    {
    setNavJulietON(); 
    }
    if (%firstNav == 2)
    {
    setNavKiloON();
     }
    if (%firstNav == 3)
    {
    setNavIndiaON();
    }
    if (%firstNav == 4)
    {
    setNavHotelON();
    }
    if (%firstNav == 5)
    {
    setNavGolfON();
    }
}
//--------------------------delayed creation of knights 30 sec after convoy-------
function setNavJulietON()
{
   %playerCount = playerManager::getPlayerCount();

   for (%p = 0; %p < %playerCount; %p++)
     {
      %player = playerManager::getPlayerNum( %p );

      %playerVeh = playerManager::playerNumToVehicleId( %player);

      setNavMarker( $navJuliet, true, %playerVeh  );
     }

//15***********try this*********
$CurrentNav = $navJuliet; 

   setHudTimer(150, -1, "Imperial Convoy ETA:", 2);
   MPcheckBoundary( enter, getObjectID ($navJuliet) , 1800, startJulietAction, 1 );
}
//----------------------------------------------------------------------------
function startJulietAction()
{
   schedule( "checkKnightJuliet();", 12 );
   schedule( "createKnightJuliet();", 9 );
   schedule( "createConvoyJuliet();", 6 );
   schedule( "killKnightJuliet();", 600 );  
}
//----------------------------------------------------------------------------
function killKnightJuliet()     //this should kill the wounded knights who runaway
{
   %obj = getObjectID($navJuliet);
   %obj1 = getObjectID($Juliet1);
   %obj2 = getObjectID($Juliet2);
   %obj3 = getObjectID($Juliet3);
   %obj4 = getObjectID($Juliet4);
   %obj5 = getObjectID($Juliet5);

   %var1 = getDistance(%obj, %obj1);
	if (%var1 >= 2500)  // test at 1000, normally 2500
	{
 	 healobject($Juliet1, -50000);
	}
   %var2 = getDistance(%obj, %obj2);
	if (%var2 >= 2500)  // test at 1000, normally 2500
	{
 	 healobject($Juliet2, -50000);
	}
   %var3 = getDistance(%obj, %obj3);
	if (%var3 >= 2500)  // test at 1000, normally 2500
	{
 	 healobject($Juliet3, -50000);
	}
   %var4 = getDistance(%obj, %obj4);
	if (%var4 >= 2500)  // test at 1000, normally 2500
	{
 	 healobject($Juliet4, -50000);
	}
   %var5 = getDistance(%obj, %obj5);
	if (%var5 >= 2500)  // test at 1000, normally 2500
	{
 	 healobject($Juliet5, -50000);
	}
      if (isGroupDestroyed( $KnightJuliet ) == false )
      {
      schedule( "killKnightJuliet();", 3 );
      }
}
//----------------------------------------------------------------------------
function setNavKiloON()
{
   %playerCount = playerManager::getPlayerCount();

   for (%p = 0; %p < %playerCount; %p++)
     {
      %player = playerManager::getPlayerNum( %p );

      %playerVeh = playerManager::playerNumToVehicleId( %player);

      setNavMarker( $navKilo, true, %playerVeh  );
     }

//15***********try this*********
$CurrentNav = $navKilo; 


   setHudTimer(150, -1, "Imperial Convoy ETA:", 2);
   MPcheckBoundary( enter, getObjectID ($navKilo) , 1800, startKiloAction, 1 );
}
//----------------------------------------------------------------------------
function startKiloAction()
{
   schedule( "checkKnightKilo();", 12 );
   schedule( "createKnightKilo();", 9 );
   schedule( "createConvoyKilo();", 6 );
   schedule( "killKnightKilo();", 600 );  
}
//----------------------------------------------------------------------------
function killKnightKilo()     //this should kill the wounded knights who runaway
{
   %obj = getObjectID($navKilo);
   %obj1 = getObjectID($Kilo1);
   %obj2 = getObjectID($Kilo2);
   %obj3 = getObjectID($Kilo3);
   %obj4 = getObjectID($Kilo4);
   %obj5 = getObjectID($Kilo5);

   %var1 = getDistance(%obj, %obj1);
	if (%var1 >= 2500)  // test at 1000, normally 2500
	{
 	 healobject($Kilo1, -50000);
	}
   %var2 = getDistance(%obj, %obj2);
	if (%var2 >= 2500)  // test at 1000, normally 2500
	{
 	 healobject($Kilo2, -50000);
	}
   %var3 = getDistance(%obj, %obj3);
	if (%var3 >= 2500)  // test at 1000, normally 2500
	{
 	 healobject($Kilo3, -50000);
	}
   %var4 = getDistance(%obj, %obj4);
	if (%var4 >= 2500)  // test at 1000, normally 2500
	{
 	 healobject($Kilo4, -50000);
	}
   %var5 = getDistance(%obj, %obj5);
	if (%var5 >= 2500)  // test at 1000, normally 2500
	{
 	 healobject($Kilo5, -50000);
	}
      if (isGroupDestroyed( $KnightKilo ) == false )
      {
      schedule( "killKnightKilo();", 3 );
      }
}
//-----------------------------------------------------------------------------
function setNavIndiaON()
{
   %playerCount = playerManager::getPlayerCount();

   for (%p = 0; %p < %playerCount; %p++)
     {
      %player = playerManager::getPlayerNum( %p );

      %playerVeh = playerManager::playerNumToVehicleId( %player);

      setNavMarker( $navIndia, true, %playerVeh  );
     }

//15***********try this*********
$CurrentNav = $navIndia; 


   setHudTimer(150, -1, "Imperial Convoy ETA:", 2);
   MPcheckBoundary( enter, getObjectID ($navIndia) , 1800, startIndiaAction, 1 );
}
//----------------------------------------------------------------------------
function startIndiaAction()
{
   schedule( "checkKnightIndia();", 12 );
   schedule( "createKnightIndia();", 9 );
   schedule( "createConvoyIndia();", 6 );
   schedule( "killKnightIndia();", 600 );  
}
//----------------------------------------------------------------------------
function killKnightIndia()     //this should kill the wounded knights who runaway
{
   %obj = getObjectID($navIndia);
   %obj1 = getObjectID($India1);
   %obj2 = getObjectID($India2);
   %obj3 = getObjectID($India3);
   %obj4 = getObjectID($India4);
   %obj5 = getObjectID($India5);

   %var1 = getDistance(%obj, %obj1);
	if (%var1 >= 2500)  // test at 1000, normally 2500
	{
 	 healobject($India1, -50000);
	}
   %var2 = getDistance(%obj, %obj2);
	if (%var2 >= 2500)  // test at 1000, normally 2500
	{
 	 healobject($India2, -50000);
	}
   %var3 = getDistance(%obj, %obj3);
	if (%var3 >= 2500)  // test at 1000, normally 2500
	{
 	 healobject($India3, -50000);
	}
   %var4 = getDistance(%obj, %obj4);
	if (%var4 >= 2500)  // test at 1000, normally 2500
	{
 	 healobject($India4, -50000);
	}
   %var5 = getDistance(%obj, %obj5);
	if (%var5 >= 2500)  // test at 1000, normally 2500
	{
 	 healobject($India5, -50000);
	}
      if (isGroupDestroyed( $KnightIndia ) == false )
      {
      schedule( "killKnightIndia();", 3 );
      }
}
//-----------------------------------------------------------------------------
function setNavHotelON()
{
   %playerCount = playerManager::getPlayerCount();

   for (%p = 0; %p < %playerCount; %p++)
     {
      %player = playerManager::getPlayerNum( %p );

      %playerVeh = playerManager::playerNumToVehicleId( %player);

      setNavMarker( $navHotel, true, %playerVeh  );
     }
//15***********try this*********
$CurrentNav = $navHotel; 


   setHudTimer(150, -1, "Imperial Convoy ETA:", 2);
   MPcheckBoundary( enter, getObjectID ($navHotel) , 1800, startHotelAction, 1 );
}
//----------------------------------------------------------------------------
function startHotelAction()
{
   schedule( "checkKnightHotel();", 12 );
   schedule( "createKnightHotel();", 9 );
   schedule( "createConvoyHotel();", 6 );
   schedule( "killKnightHotel();", 600 );  
}
//----------------------------------------------------------------------------
function killKnightHotel()     //this should kill the wounded knights who runaway
{
   %obj = getObjectID($navHotel);
   %obj1 = getObjectID($Hotel1);
   %obj2 = getObjectID($Hotel2);
   %obj3 = getObjectID($Hotel3);
   %obj4 = getObjectID($Hotel4);
   %obj5 = getObjectID($Hotel5);

   %var1 = getDistance(%obj, %obj1);
	if (%var1 >= 2500)  // test at 1000, normally 2500
	{
 	 healobject($Hotel1, -50000);
	}
   %var2 = getDistance(%obj, %obj2);
	if (%var2 >= 2500)  // test at 1000, normally 2500
	{
 	 healobject($Hotel2, -50000);
	}
   %var3 = getDistance(%obj, %obj3);
	if (%var3 >= 2500)  // test at 1000, normally 2500
	{
 	 healobject($Hotel3, -50000);
	}
   %var4 = getDistance(%obj, %obj4);
	if (%var4 >= 2500)  // test at 1000, normally 2500
	{
 	 healobject($Hotel4, -50000);
	}
   %var5 = getDistance(%obj, %obj5);
	if (%var5 >= 2500)  // test at 1000, normally 2500
	{
 	 healobject($Hotel5, -50000);
	}
      if (isGroupDestroyed( $KnightHotel ) == false )
      {
      schedule( "killKnightHotel();", 3 );
      }
}
//-----------------------------------------------------------------------------
function setNavGolfON()
{
   %playerCount = playerManager::getPlayerCount();

   for (%p = 0; %p < %playerCount; %p++)
     {
      %player = playerManager::getPlayerNum( %p );

      %playerVeh = playerManager::playerNumToVehicleId( %player);

      setNavMarker( $navGolf, true, %playerVeh  );
     }

//15***********try this*********
$CurrentNav = $navGolf; 

   setHudTimer(150, -1, "Imperial Convoy ETA:", 2);
   MPcheckBoundary( enter, getObjectID ($navGolf) , 1800, startGolfAction, 1 );
}
//----------------------------------------------------------------------------
function startGolfAction()
{
   schedule( "checkKnightGolf();", 12 );
   schedule( "createKnightGolf();", 9 );
   schedule( "createConvoyGolf();", 6 );
   schedule( "killKnightGolf();", 600 );  
}
//----------------------------------------------------------------------------
function killKnightGolf()     //this should kill the wounded knights who runaway
{
   %obj = getObjectID($navGolf);
   %obj1 = getObjectID($Golf1);
   %obj2 = getObjectID($Golf2);
   %obj3 = getObjectID($Golf3);
   %obj4 = getObjectID($Golf4);
   %obj5 = getObjectID($Golf5);

   %var1 = getDistance(%obj, %obj1);
	if (%var1 >= 2500)  // test at 1000, normally 2500
	{
 	 healobject($Golf1, -50000);
	}
   %var2 = getDistance(%obj, %obj2);
	if (%var2 >= 2500)  // test at 1000, normally 2500
	{
 	 healobject($Golf2, -50000);
	}
   %var3 = getDistance(%obj, %obj3);
	if (%var3 >= 2500)  // test at 1000, normally 2500
	{
 	 healobject($Golf3, -50000);
	}
   %var4 = getDistance(%obj, %obj4);
	if (%var4 >= 2500)  // test at 1000, normally 2500
	{
 	 healobject($Golf4, -50000);
	}
   %var5 = getDistance(%obj, %obj5);
	if (%var5 >= 2500)  // test at 1000, normally 2500
	{
 	 healobject($Golf5, -50000);
	}
      if (isGroupDestroyed( $KnightGolf ) == false )
      {
      schedule( "killKnightGolf();", 3 );
      }
}
//-----------------------------------------------------------------------------
function setNavTransportON()
{
   %playerCount = playerManager::getPlayerCount();

   for (%p = 0; %p < %playerCount; %p++)
     {
      %player = playerManager::getPlayerNum( %p );

      %playerVeh = playerManager::playerNumToVehicleId( %player);

      setNavMarker( $navTransport, true, %playerVeh  );
     }

//15***********try this*********
$CurrentNav = $navTransport; 


schedule( "say(0, 0, \"<F5>TAC-COM:  Get to the Dropship for pickup.  Good work!\");", 2 );     
//schedule( "say(0, 0, \"<F5>TAC-COM:  The Imps have grown desperate.  Contrary  to the conventions of war, certain of their men have been fitted with suicide bombs.  Do not close with them.  Destroy them utterly and completely at long range.  Do not take their surrender.\");", 7 );     
schedule( "winCondition();", 600 );
schedule( "$Baddies = false;", 300 );
schedule( "say(0, 0, \"<F5>TAC-COM:  Get to the Dropship for pickup.\");", 150 );     
schedule( "say(0, 0, \"<F5>TAC-COM:  Please get to the Dropship for pickup.\");", 300 );     
schedule( "say(0, 0, \"<F5>TAC-COM:  Awww heck, the Dropship is gonna run out of beer.\");", 450 );     
}
//-----------------------------------------------------------------------------

function init()
{


$navTransport = "MissionGroup/navPoints/navTransport";
$navJuliet = "MissionGroup/navPoints/navJuliet";
$navKilo = "MissionGroup/navPoints/navKilo";
$navIndia = "MissionGroup/navPoints/navIndia";
$navHotel = "MissionGroup/navPoints/navHotel";
$navGolf = "MissionGroup/navPoints/navGolf";
$hercD = "MissionGroup/dropshipGroup/flyer1";

//15***********try this*********
$CurrentNav = $navTransport; 

$nummies = 0;
$endnummies = 0;
$Rock1 = "MissionGroup/Rocks/Rock1";
$Rock2 = "MissionGroup/Rocks/Rock2";
$Rock3 = "MissionGroup/Rocks/Rock3";
$Rock4 = "MissionGroup/Rocks/Rock4";
$Rock5 = "MissionGroup/Rocks/Rock5";

$mineJuliet ="MissionGroup/mineJuliet/Explosives";
$mineKilo ="MissionGroup/mineKilo/Explosives";
$mineIndia ="MissionGroup/mineIndia/Explosives";
$mineHotel ="MissionGroup/mineHotel/Explosives";
$mineGolf ="MissionGroup/mineGolf/Explosives";

//Knight stuff
   newObject ("Knights", SimGroup);
   addToSet ("MissionGroup","Knights");
   $Knights = "MissionGroup/Knights";

   newObject ("KnightJuliet", SimGroup);
   addToSet ("MissionGroup/Knights", "KnightJuliet");
   $KnightJuliet = "MissionGroup/Knights/KnightJuliet";

   newObject ("KnightKilo", SimGroup);
   addToSet ("MissionGroup/Knights", "KnightKilo");
   $KnightKilo = "MissionGroup/Knights/KnightKilo";

   newObject ("KnightIndia", SimGroup);
   addToSet ("MissionGroup/Knights", "KnightIndia");
   $KnightIndia = "MissionGroup/Knights/KnightIndia";

   newObject ("KnightHotel", SimGroup);
   addToSet ("MissionGroup/Knights", "KnightHotel");
   $KnightHotel = "MissionGroup/Knights/KnightHotel";

   newObject ("KnightGolf", SimGroup);
   addToSet ("MissionGroup/Knights", "KnightGolf");
   $KnightGolf = "MissionGroup/Knights/KnightGolf";

//Convoy Stuff

   newObject ("ConvoyJuliet", SimGroup);
   addToSet ("MissionGroup", "ConvoyJuliet");
   $ConvoyJuliet   = "MissionGroup/ConvoyJuliet";

   newObject ("ConvoyKilo", SimGroup);
   addToSet ("MissionGroup", "ConvoyKilo");
   $ConvoyKilo   = "MissionGroup/ConvoyKilo";

   newObject ("ConvoyIndia", SimGroup);
   addToSet ("MissionGroup", "ConvoyIndia");
   $ConvoyIndia   = "MissionGroup/ConvoyIndia";

   newObject ("ConvoyHotel", SimGroup);
   addToSet ("MissionGroup", "ConvoyHotel");
   $ConvoyHotel   = "MissionGroup/ConvoyHotel";

   newObject ("ConvoyGolf", SimGroup);
   addToSet ("MissionGroup", "ConvoyGolf");
   $ConvoyGolf   = "MissionGroup/ConvoyGolf";

   $Baddies = false;

   $attackStarted = false;

   MPcheckBoundary( leave, getObjectID ($navTransport) , 250, onLeaveNavTransportWarning, 1 );

}




//-----------------------------------------------------------------------------
function onArriveNavTransport()
{
 %obj1 = getObjectID ( $navTransport );
 %howMany = countLivePlayers ();
 %howManyAreClose = 0;
   %playerCount = playerManager::getPlayerCount();
   for (%p = 0; %p < %playerCount; %p++)
     {
      %player = playerManager::getPlayerNum( %p );
      %playerVeh = playerManager::playerNumToVehicleId( %player);
      if (( %playerVeh != "" ) &&
          (isGroupDestroyed (%playerVeh) == false))
       {
          %var = getDistance( %obj1, %playerVeh );
          if ( %var < 300 ) %howManyAreClose++;
       }
     }
  if ( %howManyAreClose == %howMany ) 
    {
     winCondition();
    }
   else
    {
      schedule ("onArriveNavTransport();", 10 );
    }
}
//----------------------------------------------------------------------------
function onLeaveNavTransportWarning ()
{

   $actionStarted = true;
   say (0,0, "<F6><f5>You are leaving the drop zone. By doing so you will start the mission.");

// schedule( "say(0, 0, \"<F5>TAC-COM:  Your Hercs have the new MedPak.  Scan your Squad to heal and reload them.\");", 2 );     
schedule( "say(0, 0, \"<F5>TAC-COM:  Our scouts are reporting our mines under attack, we will set navs to guide you.\");", 5 );     
schedule( "say(0, 0, \"<F5>TAC-COM:  Don't let the Imperial Patrols get there before you do.\");", 10 );     
schedule( "say(0, 0, \"<F5>TAC-COM:  The Imp Convoys have explosive fuel trucks.  Blow them up before they reach the mines.\");", 18 );     





          setfirstNavON();



   $attackStarted = true;
   $Baddies = true;


       schedule ("createbackup();", 3 );  
//       schedule ("createbackup();", 13 );  
//       schedule ("createbackup();", 15 );  
      schedule ("onArriveNavTransport();", 300 );

}
//------------------------------------------------------------------------------
function createDropShip()
{
  %x = getPosition($navTransport,x);
  %y = getPosition($navTransport,y);
  %z = getPosition($navTransport,z);
  $hercD = NewObject( "Drop Ship", Flyer, 130); // terran drop ship

  newObject( "dropShipGroup", SimGroup );
  addToSet( "MissionGroup", "dropShipGroup" );
  addToSet( "MissionGroup/dropShipGroup", $hercD );

  setTeam(%herc, *IDSTR_TEAM_YELLOW);
  setPilotId ($hercD,29);

//getposition of navTransport - test
  setPosition ($hercD, %x, %y, %z);

// don't let that ship take off!
   order( $hercD, shutdown, True );
}
//-----------------Copy these 3 sections 4 times--------------------------------------
function createKnightJuliet()
{
  %Imp = randomInt(10,14);
  %x = getPosition($Rock1,x);
  %y = getPosition($Rock1,y);
  %x2 = %x + 120.0;
   for (%i = 0; %i < 5; %i++)
    {
      %name = "Knight"@ %i;
      %herc = newObject( %name, Herc, %Imp );
      setTeam( %herc, *IDSTR_TEAM_RED);
      setPilotID ( %herc, 30 );
      addToSet ($KnightJuliet, %herc);
      placeObject (%herc, %x2, %y,  180);
//set to guard the trucks
      order( %herc, guard, $ConvoyJuliet );
      order (%herc, speed, high);    
      if (%i == 0)
       {
         $Juliet1 = %herc;
       }
      if (%i == 1)
       {
         $Juliet2= %herc;
       }
      if (%i == 2)
       {
         $Juliet3 = %herc;
       }
      if (%i == 3)
       {
         $Juliet4 = %herc;
       }
      if (%i == 4)
       {
         $Juliet5 = %herc;
       }      
      %y = %y + 15;

    }
}
//--------------------------------------------------------------------------
function createKnightKilo()
{
  %Imp = randomInt(10,14);
  %x = getPosition($Rock2,x);
  %y = getPosition($Rock2,y);
  %x2 = %x + 120.0;
   for (%i = 0; %i < 5; %i++)
    {
      %name = "Knight"@ %i;
      %herc = newObject( %name, Herc, %Imp );
      setTeam( %herc, *IDSTR_TEAM_RED);
      setPilotID ( %herc, 30 );
      addToSet ($KnightKilo, %herc);
      placeObject (%herc, %x2, %y,  180);
//set to guard the trucks
      order( %herc, guard, $ConvoyKilo );
      order (%herc, speed, high);    
      if (%i == 0)
       {
         $Kilo1 = %herc;
       }
      if (%i == 1)
       {
         $Kilo2 = %herc;
       }
      if (%i == 2)
       {
         $Kilo3 = %herc;
       }
      if (%i == 3)
       {
         $Kilo4 = %herc;
       }
      if (%i == 4)
       {
         $Kilo5 = %herc;
       }      
      %y = %y + 15;

    }
}
//--------------------------------------------------------------------------
function createKnightIndia()
{
  %Imp = randomInt(10,14);
  %x = getPosition($Rock3,x);
  %y = getPosition($Rock3,y);
  %x2 = %x + 120.0;
   for (%i = 0; %i < 5; %i++)
    {
      %name = "Knight"@ %i;
      %herc = newObject( %name, Herc, %Imp );
      setTeam( %herc, *IDSTR_TEAM_RED);
      setPilotID ( %herc, 30 );
      addToSet ($KnightIndia, %herc);
      placeObject (%herc, %x2, %y,  180);
//set to guard the trucks
      order( %herc, guard, $ConvoyIndia );
      order (%herc, speed, high);    
      if (%i == 0)
       {
         $India1 = %herc;
       }
      if (%i == 1)
       {
         $India2 = %herc;
       }
      if (%i == 2)
       {
         $India3 = %herc;
       }
      if (%i == 3)
       {
         $India4 = %herc;
       }
      if (%i == 4)
       {
         $India5 = %herc;
       }      
      %y = %y + 15;

    }
}
//--------------------------------------------------------------------------
function createKnightHotel()
{
  %Imp = randomInt(10,14);
  %x = getPosition($Rock4,x);
  %y = getPosition($Rock4,y);
  %x2 = %x + 120.0;
   for (%i = 0; %i < 5; %i++)
    {
      %name = "Knight"@ %i;
      %herc = newObject( %name, Herc, %Imp );
      setTeam( %herc, *IDSTR_TEAM_RED);
      setPilotID ( %herc, 30 );
      addToSet ($KnightHotel, %herc);
      placeObject (%herc, %x2, %y,  180);
//set to guard the trucks
      order( %herc, guard, $ConvoyHotel );
      order (%herc, speed, high);    
      if (%i == 0)
       {
         $Hotel1 = %herc;
       }
      if (%i == 1)
       {
         $Hotel2 = %herc;
       }
      if (%i == 2)
       {
         $Hotel3 = %herc;
       }
      if (%i == 3)
       {
         $Hotel4 = %herc;
       }
      if (%i == 4)
       {
         $Hotel5 = %herc;
       }      
      %y = %y + 15;

    }
}
//--------------------------------------------------------------------------
function createKnightGolf()
{
  %Imp = randomInt(10,14);
  %x = getPosition($Rock5,x);
  %y = getPosition($Rock5,y);
  %x2 = %x + 120.0;
   for (%i = 0; %i < 5; %i++)
    {
      %name = "Knight"@ %i;
      %herc = newObject( %name, Herc, %Imp );
      setTeam( %herc, *IDSTR_TEAM_RED);
      setPilotID ( %herc, 30 );
      addToSet ($KnightGolf, %herc);
      placeObject (%herc, %x2, %y,  180);
//set to guard the trucks
      order( %herc, guard, $ConvoyGolf );
      order (%herc, speed, high);    
      if (%i == 0)
       {
         $Golf1 = %herc;
       }
      if (%i == 1)
       {
         $Golf2 = %herc;
       }
      if (%i == 2)
       {
         $Golf3 = %herc;
       }
      if (%i == 3)
       {
         $Golf4 = %herc;
       }
      if (%i == 4)
       {
         $Golf5 = %herc;
       }      
      %y = %y + 15;

    }
}
//--------------------------------------------------------------------------
function createConvoyJuliet()
{

  %x = getPosition($Rock1,x);
  %y = getPosition($Rock1,y);
  %x2 = %x + 20.0;
  %y2 = %y + 20.0;

   for (%i = 0; %i < 2; %i++)
    {
      %name = "Carrier"@ %i;
      %herc = newObject( %name, Tank, 65 );
      setTeam( %herc, *IDSTR_TEAM_RED);
     setPilotID ( %herc, 28 );
      addToSet ($ConvoyJuliet, %herc);
      placeObject(%herc, %x2, %y2, 180);
      order( %herc, guard, $navJuliet);
      if (%i == 0)
       {
         %truck1 = %herc;
       }
      if (%i == 1)
       {
         %truck2 = %herc;
       }
      %y2 = %y2 + 25;
    }

   for (%i = 0; %i < 1; %i++)
    {
      %name = "Ammo"@ %i;
      %herc = newObject( %name, Tank, 64 );
      setTeam( %herc, *IDSTR_TEAM_RED);
     setPilotID ( %herc, 28 );
      addToSet ($ConvoyJuliet, %herc);
      placeObject(%herc, %x, %y, 180);
      order( %herc, guard, $navJuliet);
      if (%i == 0)
       {
         $AmmoJuliet = %herc;
       }
      %y2 = %y2 + 25;
    }

}
//------------------------------------------------------------------------------
function createConvoyKilo()
{

  %x = getPosition($Rock2,x);
  %y = getPosition($Rock2,y);
  %x2 = %x + 20.0;
  %y2 = %y + 20.0;

   for (%i = 0; %i < 2; %i++)
    {
      %name = "Carrier"@ %i;
      %herc = newObject( %name, Tank, 65 );
      setTeam( %herc, *IDSTR_TEAM_RED);
     setPilotID ( %herc, 28 );
      addToSet ($ConvoyKilo, %herc);
      placeObject(%herc, %x2, %y2, 180);
      order( %herc, guard, $navKilo);
      if (%i == 0)
       {
         %truck1 = %herc;
       }
      if (%i == 1)
       {
         %truck2 = %herc;
       }
      %y2 = %y2 + 25;
    }

   for (%i = 0; %i < 1; %i++)
    {
      %name = "Ammo"@ %i;
      %herc = newObject( %name, Tank, 64 );
      setTeam( %herc, *IDSTR_TEAM_RED);
     setPilotID ( %herc, 28 );
      addToSet ($ConvoyKilo, %herc);
      placeObject(%herc, %x, %y, 180);
      order( %herc, guard, $navKilo);
      if (%i == 0)
       {
         $AmmoKilo = %herc;
       }
      %y2 = %y2 + 25;
    }

}
//------------------------------------------------------------------------------
function createConvoyIndia()
{

  %x = getPosition($Rock3,x);
  %y = getPosition($Rock3,y);
  %x2 = %x + 20.0;
  %y2 = %y + 20.0;

   for (%i = 0; %i < 2; %i++)
    {
      %name = "Carrier"@ %i;
      %herc = newObject( %name, Tank, 65 );
      setTeam( %herc, *IDSTR_TEAM_RED);
     setPilotID ( %herc, 28 );
      addToSet ($ConvoyIndia, %herc);
      placeObject(%herc, %x2, %y2, 180);
      order( %herc, guard, $navIndia);
      if (%i == 0)
       {
         %truck1 = %herc;
       }
      if (%i == 1)
       {
         %truck2 = %herc;
       }
      %y2 = %y2 + 25;
    }

   for (%i = 0; %i < 1; %i++)
    {
      %name = "Ammo"@ %i;
      %herc = newObject( %name, Tank, 64 );
      setTeam( %herc, *IDSTR_TEAM_RED);
     setPilotID ( %herc, 28 );
      addToSet ($ConvoyIndia, %herc);
      placeObject(%herc, %x, %y, 180);
      order( %herc, guard, $navIndia);
      if (%i == 0)
       {
         $AmmoIndia = %herc;
       }
      %y2 = %y2 + 25;
    }

}
//------------------------------------------------------------------------------
function createConvoyHotel()
{

  %x = getPosition($Rock4,x);
  %y = getPosition($Rock4,y);
  %x2 = %x + 20.0;
  %y2 = %y + 20.0;

   for (%i = 0; %i < 2; %i++)
    {
      %name = "Carrier"@ %i;
      %herc = newObject( %name, Tank, 65 );
      setTeam( %herc, *IDSTR_TEAM_RED);
     setPilotID ( %herc, 28 );
      addToSet ($ConvoyHotel, %herc);
      placeObject(%herc, %x2, %y2, 180);
      order( %herc, guard, $navHotel);
      if (%i == 0)
       {
         %truck1 = %herc;
       }
      if (%i == 1)
       {
         %truck2 = %herc;
       }
      %y2 = %y2 + 25;
    }

   for (%i = 0; %i < 1; %i++)
    {
      %name = "Ammo"@ %i;
      %herc = newObject( %name, Tank, 64 );
      setTeam( %herc, *IDSTR_TEAM_RED);
     setPilotID ( %herc, 28 );
      addToSet ($ConvoyHotel, %herc);
      placeObject(%herc, %x, %y, 180);
      order( %herc, guard, $navHotel);
      if (%i == 0)
       {
         $AmmoHotel = %herc;
       }
      %y2 = %y2 + 25;
    }

}
//------------------------------------------------------------------------------
function createConvoyGolf()
{

  %x = getPosition($Rock5,x);
  %y = getPosition($Rock5,y);
  %x2 = %x + 20.0;
  %y2 = %y + 20.0;

   for (%i = 0; %i < 2; %i++)
    {
      %name = "Carrier"@ %i;
      %herc = newObject( %name, Tank, 65 );
      setTeam( %herc, *IDSTR_TEAM_RED);
     setPilotID ( %herc, 28 );
      addToSet ($ConvoyGolf, %herc);
      placeObject(%herc, %x2, %y2, 180);
      order( %herc, guard, $navGolf);
      if (%i == 0)
       {
         %truck1 = %herc;
       }
      if (%i == 1)
       {
         %truck2 = %herc;
       }
      %y2 = %y2 + 25;
    }

   for (%i = 0; %i < 1; %i++)
    {
      %name = "Ammo"@ %i;
      %herc = newObject( %name, Tank, 64 );
      setTeam( %herc, *IDSTR_TEAM_RED);
     setPilotID ( %herc, 28 );
      addToSet ($ConvoyGolf, %herc);
      placeObject(%herc, %x, %y, 180);
      order( %herc, guard, $navGolf);
      if (%i == 0)
       {
         $AmmoGolf = %herc;
       }
      %y2 = %y2 + 25;
    }

}
//------------------------------------------------------------------------------
function checkKnightJuliet()
{
    if (( isGroupDestroyed( $KnightJuliet ) == true )&&($nummies <= 3))
     {
     $endnummies++;
     $nummies++;
     schedule( "say( 0, 0, \"GEN_OC01.wav\" );", 3 );
     schedule ("setNavIndiaON();", 1 );
     schedule( "say(0, 0, \"<F5>TAC-COM:  Imp squad destroyed.  \");", 2 );     
     }
    else if (( isGroupDestroyed( $KnightJuliet ) == true )&&($nummies == 4))
     {
     $endnummies++;
     $nummies++;
     schedule( "say( 0, 0, \"GEN_OC01.wav\" );", 3 );
     schedule ("setNavTransportON();", 1 );
     schedule( "say(0, 0, \"<F5>TAC-COM:  Imp squad destroyed.  \");", 2 );
     createDropShip();      
     }
    else if (isGroupDestroyed( $KnightJuliet ) == false )
     {
     schedule( "checkKnightJuliet();", 3 );
     }
}
//------------------------------------------------------------------------------
function checkKnightKilo()
{
    if (( isGroupDestroyed( $KnightKilo ) == true )&&($nummies <= 3))
     {
     $endnummies++;
     $nummies++;
     schedule( "say( 0, 0, \"GEN_OC01.wav\" );", 3 );
     schedule ("setNavGolfON();", 1 );
     schedule( "say(0, 0, \"<F5>TAC-COM:  Imp squad destroyed.  \");", 2 );     
     }
    else if (( isGroupDestroyed( $KnightKilo ) == true )&&($nummies == 4))
     {
     $endnummies++;
     $nummies++;
     schedule( "say( 0, 0, \"GEN_OC01.wav\" );", 3 );
     schedule ("setNavTransportON();", 1 );
     schedule( "say(0, 0, \"<F5>TAC-COM:  Imp squad destroyed.  \");", 2 );
     createDropShip();            
     }
    else if (isGroupDestroyed( $KnightKilo ) == false )
     {
     schedule( "checkKnightKilo();", 3 );
     }
}
//------------------------------------------------------------------------------
function checkKnightIndia()
{
    if (( isGroupDestroyed( $KnightIndia ) == true )&&($nummies <= 3))
     {
     $endnummies++;
     $nummies++;
     schedule( "say( 0, 0, \"GEN_OC01.wav\" );", 3 );
     schedule ("setNavKiloON();", 1 );
     schedule( "say(0, 0, \"<F5>TAC-COM:  Imp squad destroyed.  \");", 2 );      
     }
    else if (( isGroupDestroyed( $KnightIndia ) == true )&&($nummies == 4))
     {
     $endnummies++;
     $nummies++;
     schedule( "say( 0, 0, \"GEN_OC01.wav\" );", 3 );
     schedule ("setNavTransportON();", 1 );
     schedule( "say(0, 0, \"<F5>TAC-COM:  Imp squad destroyed.  \");", 2 );
     createDropShip();            
     }
    else if (isGroupDestroyed( $KnightIndia ) == false )
     {
     schedule( "checkKnightIndia();", 3 );
     }
}
//------------------------------------------------------------------------------
function checkKnightHotel()
{
    if (( isGroupDestroyed( $KnightHotel ) == true )&&($nummies <= 3))
     {
     $endnummies++;
     $nummies++;
     schedule( "say( 0, 0, \"GEN_OC01.wav\" );", 3 );
     schedule ("setNavJulietON();", 1 );
     schedule( "say(0, 0, \"<F5>TAC-COM:  Imp squad destroyed.  \");", 2 );      
     }
    else if (( isGroupDestroyed( $KnightHotel ) == true )&&($nummies == 4))
     {
     $endnummies++;
     $nummies++;
     schedule( "say( 0, 0, \"GEN_OC01.wav\" );", 3 );
     schedule ("setNavTransportON();", 1 );
     schedule( "say(0, 0, \"<F5>TAC-COM:  Imp squad destroyed.  \");", 2 );
     createDropShip();            
     }
    else if (isGroupDestroyed( $KnightHotel ) == false )
     {
     schedule( "checkKnightHotel();", 3 );
     }
}
//------------------------------------------------------------------------------
function checkKnightGolf()
{
    if (( isGroupDestroyed( $KnightGolf ) == true )&&($nummies <= 3))
     {
     $endnummies++;
     $nummies++;
     schedule( "say( 0, 0, \"GEN_OC01.wav\" );", 3 );
     schedule ("setNavHotelON();", 1 );
     schedule( "say(0, 0, \"<F5>TAC-COM:  Imp squad destroyed.  \");", 2 );      
     }
    else if (( isGroupDestroyed( $KnightGolf ) == true )&&($nummies == 4))
     {
     $endnummies++;
     $nummies++;
     schedule( "say( 0, 0, \"GEN_OC01.wav\" );", 3 );
     schedule ("setNavTransportON();", 1 );
     schedule( "say(0, 0, \"<F5>TAC-COM:  Imp squad destroyed.  \");", 2 );
     createDropShip();            
     }
    else if (isGroupDestroyed( $KnightGolf ) == false )
     {
     schedule( "checkKnightGolf();", 3 );
     }
}
//------------------------------------------------------------------------------
function MPcheckBoundary( %dir, %obj2, %distance, %callback, %time )
{
// This is a modification of the campaign function "CheckBoundary"
//
// %dir  - enter or leave
// %obj2 - any object you want the players distance compared to
//         must be an ID (use getObjectid) and not a string ("MissionGroup/RedHerc/h1")
// %distance - if entering, they'd be within this range to run the function
//             if leaving, they'd be outside this range to run the function
// %callback - name of the function to run
// %time - when to reschedule the next check

  %jobRun = false;

   %playerCount = playerManager::getPlayerCount();

   for(%i=0; %i < %playerCount ; %i++)
     {
     %player = playerManager::getPlayerNum( %i );

     %obj1= playerManager::playerNumToVehicleId( %player);

   %var = getDistance( %obj1, %obj2 );

    if (%var != "0")
     {
     if( %dir == "enter" || %dir == "Enter" )
       {
        if( %var <= %distance )
          {
          if ( %jobRun == false )
            {
              %func = %callback @ "(" @ %obj1 @ ");";
              schedule( %func, 0 );
              %jobRun = true;
            }
          }
       }
    else if( %dir == "leave" || %dir == "Leave" )
      {
       if( %var >= %distance )
         {
          if ( %jobRun == false )
            {
              %func = %callback @ "();";
              schedule( %func, 0 );
              %jobRun = true;
            }
         }
      }
    }
  } // end for loop

  if  (%jobRun != true )
   {
   schedule( "MPcheckBoundary( "
             @ %dir @ ", "
             @ %obj2 @ ", "
             @ %distance @ ", "
             @ %callback @ ", "
             @ %time @ ");",
             %time );

   }

}



//-------------666----------------------------------------------------------------
function pickPlayer ()
{

// 100 so we can be assured of getting a live player
   for (%p = 0; %p < 100; %p++)
     {
      %player = playerManager::getPlayerNum( randomInt( 0, playerManager::getPlayerCount() - 1 ) );

      %playerVeh = playerManager::playerNumToVehicleId( %player);

      if (( %playerVeh != "" ) &&
          (isGroupDestroyed (%playerVeh) == false))
       {
         return %playerVeh;
       }
     }
  return 0;

}
//------------686-----------------------------------------------------------------
function structure::onDestroyed(%this, %who)
{
	if (%this == getObjectId ($mineJuliet) )
	{
       $endnummies--;
       damageArea($mineJuliet, 0, 0, 0, 400, 7500000);
       schedule( "say(0, 0, \"<F5>TAC-COM:  Mine Juliet destroyed.  This isn't going well.  \");", 2 );     
	}
	if (%this == getObjectId ($mineKilo) )
	{
       $endnummies--;
       damageArea($mineKilo, 0, 0, 0, 400, 7500000);
       schedule( "say(0, 0, \"<F5>TAC-COM:  Mine Kilo destroyed.  This isn't going well.  \");", 2 );     
	}
	if (%this == getObjectId ($mineIndia) )
	{
       $endnummies--;
       damageArea($mineIndia, 0, 0, 0, 400, 7500000);
       schedule( "say(0, 0, \"<F5>TAC-COM:  Mine India destroyed.  This isn't going well.  \");", 2 );     
	}
	if (%this == getObjectId ($mineHotel) )
	{
       $endnummies--;
       damageArea($mineHotel, 0, 0, 0, 400, 7500000);
       schedule( "say(0, 0, \"<F5>TAC-COM:  Mine Hotel destroyed.  This isn't going well.  \");", 2 );     
	}
	if (%this == getObjectId ($mineGolf) )
	{
       $endnummies--;
       damageArea($mineGolf, 0, 0, 0, 400, 7500000);
       schedule( "say(0, 0, \"<F5>TAC-COM:  Mine Golf destroyed.  This isn't going well.  \");", 2 );     
	}
}
//-----------------------------------------------------------------------------
function vehicle::onDestroyed(%this, %who)
{




   //688 give the death messages...
   %message = getFancyDeathMessage(getHUDName(%this), getHUDName(%who));
   if(%message != "")
   {
      say( 0, 0, %message);
   }


//--------heal and reload on kill-----------------

  if ( $actionStarted == true ) checkForPlayersDead();

//700 see if it is a player
   %player = playerManager::vehicleIdToPlayerNum(%this);
   if(%player == 0) 
   {
    schedule( "deleteObject(" @ %this @ ");", 5 );

// heal and reload the player
   healobject ( %who, 5000 );
   healobject ( %who, 5000 );
   healobject ( %who, 5000 );

  reloadObject(%who, 5000 );
  reloadObject(%who, 5000 );

  checkRedropSquad();

   }

   if ((%this != %who) &&
      (getTeam(%this) == getTeam(%who)) &&
      (getTeam(%this) == *IDSTR_TEAM_YELLOW))
    {
     %killerName = getHudName ( %who );
     %name = getHudName ( %this );

// Team kill, take action



     say(0,0,%killerName@" is being kicked for team-killing "@%name@".");
     say(%who, %who, "", "rules_violated.wav");
     %player = playerManager::vehicleIdToPlayerNum ( %who );
     kick ( %player, *IDMULT_CHAT_TEAM_KILL_KICK );

// allow TKed player to return
     say(%this, %this, "A teammate killed you. You may respawn.");
     %this.state = "tked";
    }
//----------Convoy stuff------------
	if (%this == getObjectId ($AmmoJuliet) )
	{
         damageArea($AmmoJuliet, 0, 0, 0, 400, 9000000);
	}
	if (%this == getObjectId ($AmmoKilo) )
	{
         damageArea($AmmoKilo, 0, 0, 0, 400, 9000000);
	}
	if (%this == getObjectId ($AmmoIndia) )
	{
         damageArea($AmmoIndia, 0, 0, 0, 400, 9000000);
	}
	if (%this == getObjectId ($AmmoHotel) )
	{
         damageArea($AmmoHotel, 0, 0, 0, 400, 9000000);
	}
	if (%this == getObjectId ($AmmoGolf) )
	{
         damageArea($AmmoGolf, 0, 0, 0, 400, 9000000);
	}
}

//-----------------------------------------------------------------------------
function checkForPlayersDead()
{
  %allDead = true;

   %playerCount = playerManager::getPlayerCount();

   for (%p = 0; %p < %playerCount; %p++)
     {
      %player = playerManager::getPlayerNum( %p );

      %playerVeh = playerManager::playerNumToVehicleId( %player);

      if (( %playerVeh != "" ) &&
          (isGroupDestroyed (%playerVeh) == false))
       {

         %allDead = false;
       }
     }

  if ( %allDead == true ) schedule ("missionFailed();", 3);

}


//-----------------------------------------------------------------------------
function placeObject (%object, %x, %y, %rot)
{

  if ( %rot == "" ) %rot = 0;

  %z = getTerrainHeight(%x, %y);
  setPosition (%object, %x, %y, %z + 40, %rot);

}

//-----------------------------------------------------------------------------



function winCondition()
{
  flushConsoleScheduler();

  if (( $nummies == 5  )&& ( $endnummies == 5 )) %text = %text @ "\nExcellent work team.";
  messageBox(0, "Mission Completed, " @ $nummies @ " of 5 squads destroyed & "@ $endnummies @" of 5 mines defended. "@ %text );

  deleteObject("MissionGroup");
  deleteObject("MissionCleanup");
  deleteVariables($navTransport);
  deleteVariables($navJuliet);
  deleteVariables($navKilo);
  deleteVariables($navIndia);
  deleteVariables($navHotel);
  deleteVariables($navGolf);
  deleteVariables($CurrentNav);

  deleteVariables($nummies);
  deleteVariables($endnummies);
  deleteVariables($Rock1);
  deleteVariables($Rock2);
  deleteVariables($Rock3);
  deleteVariables($Rock4);
  deleteVariables($Rock5);
  deleteVariables($mineJuliet);
  deleteVariables($mineKilo);
  deleteVariables($mineIndia);
  deleteVariables($mineHotel);
  deleteVariables($mineGolf);
  deleteVariables($Knights);
  deleteVariables($KnightJuliet);
  deleteVariables($KnightKilo);
  deleteVariables($KnightIndia);
  deleteVariables($KnightHotel);
  deleteVariables($KnightGolf);
  deleteVariables($ConvoyJuliet);
  deleteVariables($ConvoyKilo);
  deleteVariables($ConvoyIndia);
  deleteVariables($ConvoyHotel);
  deleteVariables($ConvoyGolf);
  deleteVariables($Baddies);
  deleteVariables($hercD);
  deleteVariables($Juliet1);
  deleteVariables($Juliet2);
  deleteVariables($Juliet3);
  deleteVariables($Juliet4);
  deleteVariables($Juliet5);
  deleteVariables($Kilo1);
  deleteVariables($Kilo2);
  deleteVariables($Kilo3);
  deleteVariables($Kilo4);
  deleteVariables($Kilo5);
  deleteVariables($India1);
  deleteVariables($India2);
  deleteVariables($India3);
  deleteVariables($India4);
  deleteVariables($India5);
  deleteVariables($Hotel1);
  deleteVariables($Hotel2);
  deleteVariables($Hotel3);
  deleteVariables($Hotel4);
  deleteVariables($Hotel5);
  deleteVariables($Golf1);
  deleteVariables($Golf2);
  deleteVariables($Golf3);
  deleteVariables($Golf4);
  deleteVariables($Golf5);
  deleteVariables($AmmoJuliet);
  deleteVariables($AmmoKilo);
  deleteVariables($AmmoIndia);
  deleteVariables($AmmoHotel);
  deleteVariables($AmmoGolf);
  deleteVariables($Vtec[1]);
  deleteVariables($Vtec[2]);
  deleteVariables($Vtec[3]);
  deleteVariables($Vtec[4]);
  deleteVariables($Vtec[5]);
  deleteVariables($Vtec[6]);
  deleteVariables($Vtec[7]);
  deleteVariables($Vtec[8]);
  deleteVariables($Vtec[9]);
  deleteVariables($Vtec[10]);
  deleteVariables($Vtec[11]);
  deleteVariables($Vtec[12]);
  deleteVariables($Vtec[13]);
  deleteVariables($Vtec[14]);
  deleteVariables($Vtec[15]);
  deleteVariables($Vtec[16]);
  deleteVariables($Vtec[17]);
  deleteVariables($Vtec[18]);
  deleteVariables($Vtec[19]);
  deleteVariables($Vtec[20]);
  deleteVariables($Vtec[21]);
  deleteVariables($Vtec[22]);
  deleteVariables($Vtec[23]);
  deleteVariables($Vtec[24]);
  deleteVariables($Vtec[25]);
  deleteVariables($Vtec[26]);
  deleteVariables($Vtec[27]);
  deleteVariables($Vtec[28]);
  deleteVariables($Vtec[29]);
  deleteVariables($Vtec[30]);
  deleteVariables($Vtec[31]);
  deleteVariables($Vtec[32]);
  deleteVariables($Vtec[33]);
  deleteVariables($Vtec[34]);
  deleteVariables($Vtec[35]);
  deleteVariables($Vtec[36]);
  deleteVariables($Vtec[37]);
  deleteVariables($Vtec[38]);
  deleteVariables($Vtec[39]);
  deleteVariables($Vtec[40]);
  deleteVariables($Vtec[41]);
  deleteVariables($Vtec[42]);
  deleteVariables($Vtec[43]);
  deleteVariables($Vtec[44]);
  deleteVariables($Vtec[45]);
  deleteVariables($Vtec[46]);
  deleteVariables($Vtec[47]);
  deleteVariables($Vtec[48]);
  deleteVariables($Vtec[49]);
  deleteVariables($Vtec[50]);
  deleteVariables($Vtec[51]);
  deleteVariables($Vtec[52]);
  deleteVariables($Vtec[53]);
  deleteVariables($Vtec[54]);
  deleteVariables($Vtec[55]);
  deleteVariables($Vtec[56]);
  deleteVariables($Vn);
  deleteVariables($Vtyp[1]);
  deleteVariables($Vtyp[2]);
  deleteVariables($Vtyp[3]);
  deleteVariables($Vtyp[4]);
  deleteVariables($Vtyp[5]);
  deleteVariables($Vtyp[6]);
  deleteVariables($Vtyp[7]);
  deleteVariables($Vtyp[8]);
  deleteVariables($Vtyp[9]);
  deleteVariables($Vtyp[10]);
  deleteVariables($Vtyp[11]);
  deleteVariables($Vtyp[12]);
  deleteVariables($Vtyp[13]);
  deleteVariables($Vtyp[14]);
  deleteVariables($Vtyp[15]);
  deleteVariables($Vtyp[16]);
  deleteVariables($Vtyp[17]);
  deleteVariables($Vtyp[18]);
  deleteVariables($Vtyp[19]);
  deleteVariables($Vtyp[20]);
  deleteVariables($Vtyp[21]);
  deleteVariables($Vtyp[22]);
  deleteVariables($Vtyp[23]);
  deleteVariables($Vtyp[24]);
  deleteVariables($Vtyp[25]);
  deleteVariables($Vtyp[26]);
  deleteVariables($Vtyp[27]);
  deleteVariables($Vtyp[28]);
  deleteVariables($Vtyp[29]);
  deleteVariables($Vtyp[30]);
  deleteVariables($Vtyp[31]);
  deleteVariables($Vtyp[32]);
  deleteVariables($Vtyp[33]);
  deleteVariables($Vtyp[34]);
  deleteVariables($Vtyp[35]);
  deleteVariables($Vtyp[36]);
  deleteVariables($Vtyp[37]);
  deleteVariables($Vtyp[38]);
  deleteVariables($Vtyp[39]);
  deleteVariables($Vtyp[40]);
  deleteVariables($Vtyp[41]);
  deleteVariables($Vtyp[42]);
  deleteVariables($Vtyp[43]);
  deleteVariables($Vtyp[44]);
  deleteVariables($Vtyp[45]);
  deleteVariables($Vtyp[46]);
  deleteVariables($Vtyp[47]);
  deleteVariables($Vtyp[48]);
  deleteVariables($Vtyp[49]);
  deleteVariables($Vtyp[50]);
  deleteVariables($Vtyp[51]);
  deleteVariables($Vtyp[52]);
  deleteVariables($Vtyp[53]);
  deleteVariables($Vtyp[54]);
  deleteVariables($Vtyp[55]);
  deleteVariables($Vtyp[56]);

   deleteFunctions("onMissionStart");
   deleteFunctions("onMissionLoad");
   deleteFunctions("player::onAdd");
   deleteFunctions("vehicle::onAdd");
   deleteFunctions("setfirstNavON");
   deleteFunctions("setNavJulietON");
   deleteFunctions("startJulietAction");
   deleteFunctions("killKnightJuliet");
   deleteFunctions("setNavKiloON");
   deleteFunctions("startKiloAction");
   deleteFunctions("killKnightKilo");
   deleteFunctions("setNavIndiaON");
   deleteFunctions("startIndiaAction");
   deleteFunctions("killKnightIndia");
   deleteFunctions("setNavHotelON");
   deleteFunctions("startHotelAction");
   deleteFunctions("killKnightHotel");
   deleteFunctions("setNavGolfON");
   deleteFunctions("startGolfAction");
   deleteFunctions("killKnightGolf");
   deleteFunctions("setNavTransportON");
   deleteFunctions("onArriveNavTransport");
   deleteFunctions("onLeaveNavTransportWarning");
   deleteFunctions("createDropShip");
   deleteFunctions("createKnightJuliet");
   deleteFunctions("createKnightKilo");
   deleteFunctions("createKnightIndia");
   deleteFunctions("createKnightHotel");
   deleteFunctions("createKnightGolf");
   deleteFunctions("createConvoyJuliet");
   deleteFunctions("createConvoyKilo");
   deleteFunctions("createConvoyIndia");
   deleteFunctions("createConvoyHotel");
   deleteFunctions("createConvoyGolf");
   deleteFunctions("checkKnightJuliet");
   deleteFunctions("checkKnightKilo");
   deleteFunctions("checkKnightIndia");
   deleteFunctions("checkKnightHotel");
   deleteFunctions("checkKnightGolf");
   deleteFunctions("MPcheckBoundary");
   deleteFunctions("pickPlayer");
   deleteFunctions("structure::onDestroyed");
   deleteFunctions("vehicle::onDestroyed");
   deleteFunctions("checkForPlayersDead");
   deleteFunctions("placeObject");
   deleteFunctions("winCondition");
   deleteFunctions("missionFailed");
   deleteFunctions("VehicleTech");
   deleteFunctions("getRandomAI");
   deleteFunctions("createbackup");
   deleteFunctions("createSquadTwo");
   deleteFunctions("createSquadThree");
   deleteFunctions("createSquadFour");
   deleteFunctions("createSquadFive");
   deleteFunctions("createSquadSix");
   deleteFunctions("createSquadSeven");
   deleteFunctions("createSquadEight");
   deleteFunctions("dropSquad");
   deleteFunctions("countLivePlayers");
   deleteFunctions("checkRedropSquad");
   deleteFunctions("abs");
   deleteFunctions("findSquadDropPoint");
   deleteFunctions("vehicle::onAttacked");
   deleteFunctions("vehicle::onScan");
   deleteFunctions("*::vehicle::*");
   deleteFunctions("vehicle::*");
   deleteFunctions("*::structure::*");
   deleteFunctions("structure::*");
   deleteFunctions("*::turret::*");
   deleteFunctions("turret::*");
   deleteFunctions("*::trigger::*");
   deleteFunctions("trigger::*");

  missionEndConditionMet();
  // schedule("missionEndConditionMet();", 10);
}

//-----------------------------------------------------------------------------
function missionFailed()
{
  

  flushConsoleScheduler();
  messageBox(0, "Mission Failed, better luck next time." );

  deleteObject("MissionGroup");
  deleteObject("MissionCleanup");
  deleteVariables($navTransport);
  deleteVariables($navJuliet);
  deleteVariables($navKilo);
  deleteVariables($navIndia);
  deleteVariables($navHotel);
  deleteVariables($navGolf);
  deleteVariables($CurrentNav);

  deleteVariables($nummies);
  deleteVariables($endnummies);
  deleteVariables($Rock1);
  deleteVariables($Rock2);
  deleteVariables($Rock3);
  deleteVariables($Rock4);
  deleteVariables($Rock5);
  deleteVariables($mineJuliet);
  deleteVariables($mineKilo);
  deleteVariables($mineIndia);
  deleteVariables($mineHotel);
  deleteVariables($mineGolf);
  deleteVariables($Knights);
  deleteVariables($KnightJuliet);
  deleteVariables($KnightKilo);
  deleteVariables($KnightIndia);
  deleteVariables($KnightHotel);
  deleteVariables($KnightGolf);
  deleteVariables($ConvoyJuliet);
  deleteVariables($ConvoyKilo);
  deleteVariables($ConvoyIndia);
  deleteVariables($ConvoyHotel);
  deleteVariables($ConvoyGolf);
  deleteVariables($Baddies);
  deleteVariables($hercD);
  deleteVariables($Juliet1);
  deleteVariables($Juliet2);
  deleteVariables($Juliet3);
  deleteVariables($Juliet4);
  deleteVariables($Juliet5);
  deleteVariables($Kilo1);
  deleteVariables($Kilo2);
  deleteVariables($Kilo3);
  deleteVariables($Kilo4);
  deleteVariables($Kilo5);
  deleteVariables($India1);
  deleteVariables($India2);
  deleteVariables($India3);
  deleteVariables($India4);
  deleteVariables($India5);
  deleteVariables($Hotel1);
  deleteVariables($Hotel2);
  deleteVariables($Hotel3);
  deleteVariables($Hotel4);
  deleteVariables($Hotel5);
  deleteVariables($Golf1);
  deleteVariables($Golf2);
  deleteVariables($Golf3);
  deleteVariables($Golf4);
  deleteVariables($Golf5);
  deleteVariables($AmmoJuliet);
  deleteVariables($AmmoKilo);
  deleteVariables($AmmoIndia);
  deleteVariables($AmmoHotel);
  deleteVariables($AmmoGolf);
  deleteVariables($Vtec[1]);
  deleteVariables($Vtec[2]);
  deleteVariables($Vtec[3]);
  deleteVariables($Vtec[4]);
  deleteVariables($Vtec[5]);
  deleteVariables($Vtec[6]);
  deleteVariables($Vtec[7]);
  deleteVariables($Vtec[8]);
  deleteVariables($Vtec[9]);
  deleteVariables($Vtec[10]);
  deleteVariables($Vtec[11]);
  deleteVariables($Vtec[12]);
  deleteVariables($Vtec[13]);
  deleteVariables($Vtec[14]);
  deleteVariables($Vtec[15]);
  deleteVariables($Vtec[16]);
  deleteVariables($Vtec[17]);
  deleteVariables($Vtec[18]);
  deleteVariables($Vtec[19]);
  deleteVariables($Vtec[20]);
  deleteVariables($Vtec[21]);
  deleteVariables($Vtec[22]);
  deleteVariables($Vtec[23]);
  deleteVariables($Vtec[24]);
  deleteVariables($Vtec[25]);
  deleteVariables($Vtec[26]);
  deleteVariables($Vtec[27]);
  deleteVariables($Vtec[28]);
  deleteVariables($Vtec[29]);
  deleteVariables($Vtec[30]);
  deleteVariables($Vtec[31]);
  deleteVariables($Vtec[32]);
  deleteVariables($Vtec[33]);
  deleteVariables($Vtec[34]);
  deleteVariables($Vtec[35]);
  deleteVariables($Vtec[36]);
  deleteVariables($Vtec[37]);
  deleteVariables($Vtec[38]);
  deleteVariables($Vtec[39]);
  deleteVariables($Vtec[40]);
  deleteVariables($Vtec[41]);
  deleteVariables($Vtec[42]);
  deleteVariables($Vtec[43]);
  deleteVariables($Vtec[44]);
  deleteVariables($Vtec[45]);
  deleteVariables($Vtec[46]);
  deleteVariables($Vtec[47]);
  deleteVariables($Vtec[48]);
  deleteVariables($Vtec[49]);
  deleteVariables($Vtec[50]);
  deleteVariables($Vtec[51]);
  deleteVariables($Vtec[52]);
  deleteVariables($Vtec[53]);
  deleteVariables($Vtec[54]);
  deleteVariables($Vtec[55]);
  deleteVariables($Vtec[56]);
  deleteVariables($Vn);
  deleteVariables($Vtyp[1]);
  deleteVariables($Vtyp[2]);
  deleteVariables($Vtyp[3]);
  deleteVariables($Vtyp[4]);
  deleteVariables($Vtyp[5]);
  deleteVariables($Vtyp[6]);
  deleteVariables($Vtyp[7]);
  deleteVariables($Vtyp[8]);
  deleteVariables($Vtyp[9]);
  deleteVariables($Vtyp[10]);
  deleteVariables($Vtyp[11]);
  deleteVariables($Vtyp[12]);
  deleteVariables($Vtyp[13]);
  deleteVariables($Vtyp[14]);
  deleteVariables($Vtyp[15]);
  deleteVariables($Vtyp[16]);
  deleteVariables($Vtyp[17]);
  deleteVariables($Vtyp[18]);
  deleteVariables($Vtyp[19]);
  deleteVariables($Vtyp[20]);
  deleteVariables($Vtyp[21]);
  deleteVariables($Vtyp[22]);
  deleteVariables($Vtyp[23]);
  deleteVariables($Vtyp[24]);
  deleteVariables($Vtyp[25]);
  deleteVariables($Vtyp[26]);
  deleteVariables($Vtyp[27]);
  deleteVariables($Vtyp[28]);
  deleteVariables($Vtyp[29]);
  deleteVariables($Vtyp[30]);
  deleteVariables($Vtyp[31]);
  deleteVariables($Vtyp[32]);
  deleteVariables($Vtyp[33]);
  deleteVariables($Vtyp[34]);
  deleteVariables($Vtyp[35]);
  deleteVariables($Vtyp[36]);
  deleteVariables($Vtyp[37]);
  deleteVariables($Vtyp[38]);
  deleteVariables($Vtyp[39]);
  deleteVariables($Vtyp[40]);
  deleteVariables($Vtyp[41]);
  deleteVariables($Vtyp[42]);
  deleteVariables($Vtyp[43]);
  deleteVariables($Vtyp[44]);
  deleteVariables($Vtyp[45]);
  deleteVariables($Vtyp[46]);
  deleteVariables($Vtyp[47]);
  deleteVariables($Vtyp[48]);
  deleteVariables($Vtyp[49]);
  deleteVariables($Vtyp[50]);
  deleteVariables($Vtyp[51]);
  deleteVariables($Vtyp[52]);
  deleteVariables($Vtyp[53]);
  deleteVariables($Vtyp[54]);
  deleteVariables($Vtyp[55]);
  deleteVariables($Vtyp[56]);

   deleteFunctions("onMissionStart");
   deleteFunctions("onMissionLoad");
   deleteFunctions("player::onAdd");
   deleteFunctions("vehicle::onAdd");
   deleteFunctions("setfirstNavON");
   deleteFunctions("setNavJulietON");
   deleteFunctions("startJulietAction");
   deleteFunctions("killKnightJuliet");
   deleteFunctions("setNavKiloON");
   deleteFunctions("startKiloAction");
   deleteFunctions("killKnightKilo");
   deleteFunctions("setNavIndiaON");
   deleteFunctions("startIndiaAction");
   deleteFunctions("killKnightIndia");
   deleteFunctions("setNavHotelON");
   deleteFunctions("startHotelAction");
   deleteFunctions("killKnightHotel");
   deleteFunctions("setNavGolfON");
   deleteFunctions("startGolfAction");
   deleteFunctions("killKnightGolf");
   deleteFunctions("setNavTransportON");
   deleteFunctions("onArriveNavTransport");
   deleteFunctions("onLeaveNavTransportWarning");
   deleteFunctions("createDropShip");
   deleteFunctions("createKnightJuliet");
   deleteFunctions("createKnightKilo");
   deleteFunctions("createKnightIndia");
   deleteFunctions("createKnightHotel");
   deleteFunctions("createKnightGolf");
   deleteFunctions("createConvoyJuliet");
   deleteFunctions("createConvoyKilo");
   deleteFunctions("createConvoyIndia");
   deleteFunctions("createConvoyHotel");
   deleteFunctions("createConvoyGolf");
   deleteFunctions("checkKnightJuliet");
   deleteFunctions("checkKnightKilo");
   deleteFunctions("checkKnightIndia");
   deleteFunctions("checkKnightHotel");
   deleteFunctions("checkKnightGolf");
   deleteFunctions("MPcheckBoundary");
   deleteFunctions("pickPlayer");
   deleteFunctions("structure::onDestroyed");
   deleteFunctions("vehicle::onDestroyed");
   deleteFunctions("checkForPlayersDead");
   deleteFunctions("placeObject");
   deleteFunctions("winCondition");
   deleteFunctions("missionFailed");
   deleteFunctions("VehicleTech");
   deleteFunctions("getRandomAI");
   deleteFunctions("createbackup");
   deleteFunctions("createSquadTwo");
   deleteFunctions("createSquadThree");
   deleteFunctions("createSquadFour");
   deleteFunctions("createSquadFive");
   deleteFunctions("createSquadSix");
   deleteFunctions("createSquadSeven");
   deleteFunctions("createSquadEight");
   deleteFunctions("dropSquad");
   deleteFunctions("countLivePlayers");
   deleteFunctions("checkRedropSquad");
   deleteFunctions("abs");
   deleteFunctions("findSquadDropPoint");
   deleteFunctions("vehicle::onAttacked");
   deleteFunctions("vehicle::onScan");
   deleteFunctions("*::vehicle::*");
   deleteFunctions("vehicle::*");
   deleteFunctions("*::structure::*");
   deleteFunctions("structure::*");
   deleteFunctions("*::turret::*");
   deleteFunctions("turret::*");
   deleteFunctions("*::trigger::*");
   deleteFunctions("trigger::*");

  missionEndConditionMet();
  // schedule("missionEndConditionMet();", 10);
}

//----------------------------------------------------------------------------

//--------Boy oh Boy, Wowie, All this stuff is really, really too Cool---------
//-----------------------------------------------------------------------------
// Immutable vehicle attributes
//   tec: 0 = not applicable, 1 = Cybrid, 2 = Human
//   typ: 0 = not applicable, 1 = Herc, 2 = Tank, 3 = Drone, 4 = Flyer
// * denotes non-standard vehicles ordinarily prohibited to human players
// NA denotes ids for which no vehicle exists
$Vtec[1]=2;$Vtyp[1]=1;//TerranApocalypse
$Vtec[2]=2;$Vtyp[2]=1;//TerranMinotaur
$Vtec[3]=2;$Vtyp[3]=1;//TerranGorgon
$Vtec[4]=2;$Vtyp[4]=1;//TerranTalon
$Vtec[5]=2;$Vtyp[5]=1;//TerranBasilisk
$Vtec[6]=2;$Vtyp[6]=2;//Paladin
$Vtec[7]=2;$Vtyp[7]=2;//Myrmidon
$Vtec[8]=2;$Vtyp[8]=2;//Disrupter
$Vtec[9]=0;$Vtyp[9]=4;// * Banshee
$Vtec[10]=2;$Vtyp[10]=1;//Knight'sApocalypse
$Vtec[11]=2;$Vtyp[11]=1;//Knight'sMinotaur
$Vtec[12]=2;$Vtyp[12]=1;//Knight'sGorgon
$Vtec[13]=2;$Vtyp[13]=1;//Knight'sTalon
$Vtec[14]=2;$Vtyp[14]=1;//Knight'sBasilisk
$Vtec[15]=2;$Vtyp[15]=2;//KnightPaladin
$Vtec[16]=2;$Vtyp[16]=2;//KnightMyrmidon
$Vtec[17]=2;$Vtyp[17]=2;//KnightDisrupter
$Vtec[18]=0;$Vtyp[18]=4;// * TerranCargo
$Vtec[19]=0;$Vtyp[19]=4;// * TerranEscape
$Vtec[20]=1;$Vtyp[20]=1;//Seeker
$Vtec[21]=1;$Vtyp[21]=1;//Goad
$Vtec[22]=1;$Vtyp[22]=1;//Shepherd
$Vtec[23]=1;$Vtyp[23]=1;//Adjudicator
$Vtec[24]=1;$Vtyp[24]=1;//Executioner
$Vtec[25]=1;$Vtyp[25]=2;//Bolo
$Vtec[26]=1;$Vtyp[26]=2;//Recluse
$Vtec[27]=1;$Vtyp[27]=1;// * PlatAdjucator
$Vtec[28]=1;$Vtyp[28]=1;// * PlatExecutor
$Vtec[29]=1;$Vtyp[29]=1;// * Prometheus
$Vtec[30]=2;$Vtyp[30]=1;//Emancipator
$Vtec[31]=2;$Vtyp[31]=2;//Avenger
$Vtec[32]=2;$Vtyp[32]=2;//Dreadlock
$Vtec[33]=2;$Vtyp[33]=1;//Olympian
$Vtec[34]=0;$Vtyp[34]=0;// NA
$Vtec[35]=1;$Vtyp[35]=1;//MetagenSeeker
$Vtec[36]=1;$Vtyp[36]=1;//MetagenGoad
$Vtec[37]=1;$Vtyp[37]=1;//MetagenShepherd
$Vtec[38]=1;$Vtyp[38]=1;// * MetagenAdjucator
$Vtec[39]=1;$Vtyp[39]=1;// * MetagenExecutor
$Vtec[40]=2;$Vtyp[40]=1;// * Harabec'sApocalypse
$Vtec[41]=2;$Vtyp[41]=2;//Predator
$Vtec[42]=2;$Vtyp[42]=1;// * Caanon's Basilisk?
$Vtec[43]=2;$Vtyp[43]=1;// * Cinematic Apocalypse
$Vtec[44]=2;$Vtyp[44]=1;// * Cinematic Basilisk
$Vtec[45]=2;$Vtyp[45]=2;// * Super Predator
$Vtec[46]=0;$Vtyp[46]=0;// NA
$Vtec[47]=0;$Vtyp[47]=0;// NA
$Vtec[48]=0;$Vtyp[48]=0;// NA
$Vtec[49]=0;$Vtyp[49]=0;// NA
$Vtec[50]=2;$Vtyp[50]=1;// * PirateApocalypse
$Vtec[51]=2;$Vtyp[51]=2;// * PirateDreadlock
$Vtec[52]=2;$Vtyp[52]=1;//PirateEmancipator
$Vtec[53]=0;$Vtyp[53]=0;// NA
$Vtec[54]=0;$Vtyp[54]=0;// NA
$Vtec[55]=1;$Vtyp[55]=1;//PlayerPlatAdjudicator
$Vtec[56]=1;$Vtyp[56]=1;//PlayerPlatExecutioner
$Vn = 57;
//-----------------------------------------------------------------------------
function VehicleTech(%v)
{
	if ((%v >= 1) && (%v < $Vn)) %t = $Vtec[%v];
	else if ((%v >= 60) && (%v <= 73)) %t = 0;
	else if (%v == 90) %t = 1;
	else if ((%v >= 91) && (%v <= 93)) %t = 0;
	else if ((%v >= 94) && (%v <= 96)) %t = 0;
	else if ((%v >= 110) && (%v <= 111)) %t = 0;
	else if ((%v >= 130) && (%v <= 132)) %t = 0;
	else if ((%v >= 133) && (%v <= 134)) %t = 2;
	else if ((%v >= 135) && (%v <= 136)) %t = 0;
	else if ((%v >= 137) && (%v <= 138)) %t = 2;
	else if (%v == 150) %t = 2;
	else %t = 0;

    return %t;


	return "?";
}

//-----------------------------------------------------------------------------
// this function uses less AI, all standard
function getRandomAI( %vehicleTech )
{

  %vehTech = -1;
%cntr = 0;

  while (( %vehTech != %vehicleTech ) ||
         ( %vehicleTech == 3 ))
   {
// check for valid ranges
     %i = RandomInt(1,28);
     if ( %i>8 && %i<10 )
        %i = RandomInt(1,8);
     if ( %i>17 && %i<20 )
        %i = RandomInt(20,28);

// get appropriate type Tank or Herc
     %type = Herc;
     if ( %i>5  && %i<= 8 )   %type = Tank;
     if ( %i>14 && %i<= 17 )  %type = Tank;
     if ( %i>24 && %i<= 26 )  %type = Tank;

     %vehTech = VehicleTech(%i);

%cntr++;

if ( %cntr > 10) break;
  }

   return NewObject( "AI" @ %i, %type, %i );
}

//-----------------------------------------------------------------------------
function createbackup()
{

   if ( $Baddies == true )
     {

     $numLivePlayers = countLivePlayers ();

     if ( $numLivePlayers >= 1 )  findSquadDropPoint ( getObjectid ($navTransport), 3, "squad1" );
     if ( $numLivePlayers >= 2 )  schedule ("createSquadTwo();", 5 );
     if ( $numLivePlayers >= 3 )  schedule ("createSquadThree();", 7 );
     if ( $numLivePlayers >= 4 )  schedule ("createSquadFour();", 9 );
     if ( $numLivePlayers >= 5 )  schedule ("createSquadFive();", 11 );
//     if ( $numLivePlayers >= 6 )  schedule ("createSquadSix();", 13 );
//     if ( $numLivePlayers >= 7 )  schedule ("createSquadSeven();", 15 );
//     if ( $numLivePlayers >= 8 )  schedule ("createSquadEight();", 17 );
     }
}
//-------------------------------------------------------------------------------


function createSquadTwo ()
{
  findSquadDropPoint ( getObjectid ($navTransport), 2, "squad2" );
}

function createSquadThree()
{
  findSquadDropPoint ( getObjectid ($navTransport), 2, "squad3" );
}

function createSquadFour ()
{
  findSquadDropPoint ( getObjectid ($navTransport), 2, "squad4" );
}

function createSquadFive ()
{
  findSquadDropPoint ( getObjectid ($navTransport), 2, "squad5" );
}

function createSquadSix ()
{
  findSquadDropPoint ( getObjectid ($navTransport), 2, "squad6" );
}

function createSquadSeven ()
{
  findSquadDropPoint ( getObjectid ($navTransport), 1, "squad7" );
}

function createSquadEight ()
{
  findSquadDropPoint ( getObjectid ($navTransport), 1, "squad8" );
}

//-----------------------------------------------------------------------------
function dropSquad(%x, %y, %howMany, %newGroup )
{
   if ( $Baddies == true )
 {


 if ( %howMany > 10 ) %howMany = 10;

  %thisGroup = "MissionGroup/" @ %newgroup;

  newObject( %newGroup, SimGroup );
  addToSet( "MissionGroup", %newGroup );

  for ( %i=0; %i < %howMany; %i++ )
    {
      %herc = getRandomAI( $OVconvoyTech );

      setTeam (%herc, *IDSTR_TEAM_RED);
      setpilotID ( %herc, 29);

      placeObject ( %herc, %x, %y, 0);

  addToSet(  %thisGroup, %herc );

      %x = %x + 100 ;
      %y = %y + 100 ;

      if ( %i == 0 )
       {
         %leadHerc = %herc;
       }


      order (%herc, speed, high);


          %targetPlayer = pickPlayer();
          order ( %herc, attack, %targetPlayer );

    }



 }

}




//-----------------------------------------------------------------------------
function countLivePlayers ()
{

  %count = 0;

   %playerCount = playerManager::getPlayerCount();

   for (%p = 0; %p < %playerCount; %p++)
     {
      %player = playerManager::getPlayerNum( %p );

      %playerVeh = playerManager::playerNumToVehicleId( %player);

      if (( %playerVeh != "" ) &&
          (isGroupDestroyed (%playerVeh) == false))
       {
         %count++;
       }
     }
  return %count;

}

//-----------------------------------------------------------------------------
function checkRedropSquad()
{
 %howMany = countLivePlayers ();

     if (( %howMany >= 1 ) &&
         ( isGroupDestroyed ("MissionGroup/squad1") == true ))
       {
//         %center = getObjectid ($navTransport);
         %center = pickPlayer();
         findSquadDropPoint ( %center, 2, "squad1" );
       }

     if (( %howMany >= 2 ) &&
         ( isGroupDestroyed ("MissionGroup/squad2") == true ))
       {
//         %center = getObjectid ($navTransport);
         %center = pickPlayer();
         findSquadDropPoint ( %center, 2, "squad2" );
       }

     if (( %howMany >= 3 ) &&
         ( isGroupDestroyed ("MissionGroup/squad3") == true ))
       {
//         %center = getObjectid ($navTransport);
         %center = pickPlayer();
         findSquadDropPoint ( %center, 2, "squad3" );
       }

     if (( %howMany >= 4 ) &&
         ( isGroupDestroyed ("MissionGroup/squad4") == true ))
       {
//         %center = getObjectid ($navTransport);
         %center = pickPlayer();
         findSquadDropPoint ( %center, 2, "squad4" );
       }
}

//-----------------------------------------------------------------------------
function abs(%n)
{
  if ( %n < 0 ) 
    {
      %n = %n * -1;
      return %n;
    }
   else
    {
      return %n;
    }
}

//-----------------------------------------------------------------------------
function findSquadDropPoint ( %centerObject, %howMany, %squadName )
{

%cntr = 0;

     %maxRange = $maxRange;
     %minRange = $minRange;

// not really a target, but the center of attention
   %target = %centerObject;

   %OVbaseX = getPosition (%target, x);
   %OVbaseY = getPosition (%target, y);

// select a drop zone
  %xDrop = RandomInt ( %OVbaseX-%maxRange, %OVbaseX+%maxRange );
  %yDrop = RandomInt ( %OVbaseY-%maxRange, %OVbaseY+%maxRange );

  %deltaX = %OVbaseX - %xDrop;
  %deltaY = %OVbaseY - %yDrop;

  %deltaX = abs ( %deltaX );
  %deltaY = abs ( %deltaY );

  %dropDistance = sqrt ( (%deltaX*%deltaX) + (%deltaY*%deltaY) );

  if  (( %dropDistance < %minRange ) ||
       ( %dropDistance > %maxRange ))
   {
     %dropDistance = randomInt ( %minRange, %maxRange );

// keep X position, for no particular reason
      %temp = (( %xDrop * %xDrop ) - ( %dropDistance * %dropDistance ));
      %temp = abs ( %temp );
      %yDrop = sqrt ( %temp );

   while (1)
   {

// select a drop zone
     %xDrop = RandomInt ( %OVbaseX-%maxRange, %OVbaseX+%maxRange );
     %yDrop = RandomInt ( %OVbaseY-%maxRange, %OVbaseY+%maxRange );

     %deltaX = %OVbaseX - %xDrop;
     %deltaY = %OVbaseY - %yDrop;

     %deltaX = abs ( %deltaX );
     %deltaY = abs ( %deltaY );

     %dropDistance = sqrt ( (%deltaX*%deltaX) + (%deltaY*%deltaY) );


  if  (( %dropDistance > %minRange ) &&
       ( %dropDistance < %maxRange ))    break;

%cntr++;
 if ( %cntr > 20 ) break;

   }

   }

 
    dropSquad (%xDrop, %yDrop, %howMany, %squadName); 
   
}

//----------------------------------------------------------------
function vehicle::onAttacked(%attacked, %attacker)
{

     if (%attacked ==  $hercD )
     {
       healobject ( %attacked, 1000 );
       healobject ( %attacked, 1000 );
//       healobject ( %attacked, 1000 );
     }

}
//-------------------MedPak---------------------------------------------

function vehicle::onScan(%scanned,%scanner)	
{
   //if ((%scanned != %scanner) &&
   //   (getTeam(%scanned) == getTeam(%scanner)) &&
   //   (getTeam(%scanned) == *IDSTR_TEAM_YELLOW))
   //    {
   //     healobject (%scanned, 2500 );
   //     reloadObject (%scanned, 2500 );
   //     %player1 = playerManager::vehicleIdToPlayerNum(%scanned);
   //     say ( %player1,1,"<f5>MedPak Engaged...","sfx_electrical_bzzt.wav");
   //     playsound(%player1,"sfx_electrical_bzzt.wav",IDPRF_2D);
   //
   //     %player2 = playerManager::vehicleIdToPlayerNum(%scanner);
   //     say ( %player2,1, "<f5>MedPak Engaged...","sfx_electrical_bzzt.wav");
   //     playsound(%player2,"sfx_electrical_bzzt.wav",IDPRF_2D);
   //    }
}
//------------------MedPak----------------------------------------------


//----------------------------------------------------------------

//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------






































































