// Invasion.cs
// by ACrisp (parts by Dolf Kooz, background speech components from Cybrid Mission CA0)
// Version 1.08f - delete variables stuff
console::enable(true);
Pilot PatrolPilot1
{
   id = 28;
   
   skill = 0.3;
   accuracy = 0.3;
   aggressiveness = 0.9;
   activateDist = 450.0;
   deactivateBuff = 300.0;
   targetFreq = 3.5;
   trackFreq = 0.2;
   fireFreq = 2.0;
   LOSFreq = 0.2;
   orderFreq = 4.0;
};

Pilot PatrolPilot2
{
   id = 29;
   
   skill = 0.4;
   accuracy = 0.4;
   aggressiveness = 0.9;
   activateDist = 450.0;
   deactivateBuff = 300.0;
   targetFreq = 3.0;
   trackFreq = 0.3;
   fireFreq = 2.0;
   LOSFreq = 0.2;
   orderFreq = 4.0;
};

Pilot PatrolPilot3
{
   id = 30;
   
   skill = 0.5;
   accuracy = 0.5;
   aggressiveness = 0.9;
   activateDist = 450.0;
   deactivateBuff = 300.0;
   targetFreq = 2.5;
   trackFreq = 0.1;
   fireFreq = 2.0;
   LOSFreq = 0.2;
   orderFreq = 4.0;
};

Pilot PatrolPilot4
{
   id = 31;
   
   skill = 0.6;
   accuracy = 0.6;
   aggressiveness = 0.9;
   activateDist = 450.0;
   deactivateBuff = 300.0;
   targetFreq = 1.5;
   trackFreq = 0.1;
   fireFreq = 2.0;
   LOSFreq = 0.2;
   orderFreq = 4.0;
};

Pilot TDFPilot
{
   id = 32;
   name = "Pvt. Raines";
   skill = 0.5;
   accuracy = 0.5;
   aggressiveness = 0.9;
   activateDist = 450.0;
   deactivateBuff = 300.0;
   targetFreq = 2.5;
   trackFreq = 0.1;
   fireFreq = 2.0;
   LOSFreq = 0.2;
   orderFreq = 4.0;
};

$missionName = "Escort_Duty";

$server::TeamDamage = true;

//exec("multiplayerStdLib.cs");
//exec("DMstdLib.cs");

//------------ADD AS A TEST---------------
function setDefaultMissionOptions()
{
	$server::TeamPlay = true;
	$server::AllowDeathmatch = False;
	$server::AllowTeamPlay = true;	

   // what can the client choose for a team
	$server::AllowTeamRed = true;
	$server::AllowTeamBlue = False;
	$server::AllowTeamYellow = true;
	$server::AllowTeamPurple = False;

   // what can the server admin choose for available teams
   $server::disableTeamRed = False;
   $server::disableTeamBlue = true;
   $server::disableTeamYellow = False;
   $server::disableTeamPurple = true;

}
//---------ADD AS A TEST-------------------

function onMissionStart()
{
	
        init();
}

function onMissionLoad()
{
   
   cdAudioCycle("ss4", "ss1", "ss3"); 
    $textMsg = "Mission Credits:  A. Crisp,  "@    
      "Patrol the vicinity around our command base.\n\n"@
      "Complete Objectives:"@
      "\n1) Escort utility truck to the Tracking Station at nav Alpha."@
      "\n2) Investigate sensor anomalies at nav Bravo."@
      "\n3) Destroy all hostiles encountered.\n"@
   "Respawning is not allowed. Scanning the repair truck heals your vehicle and"@
   " reloads your weapons. Team Damage is on, watch your fire.";

   %history = 
"\n\nDate: 2829.3805. Welcome to the TDF Reserve Base on Mercury.  Lately we've been picking up some anomalous signals in solar orbit, but the solar storms have kept us from identifying them properly.  Repair crews have been dispatched to adjust our tracking stations and hopefully compensate for the increased interference.\n\n" @
"While the crews do their work, your squad is ordered to patrol the vicinity around our forward command base.  While we've never had any rebel strikes here, they might take advantage of the storms cover to launch an attack.  Keep your eyes open for any suspicious activity.\n\n"@
"Get your Hercs ready, and good luck.";

   setGameInfo ($textMsg @ %history);

}

//-----------------------------------------------------------------------------
function init()
{
   
   newObject (tauntsVol, SimVolume, "CA0.vol");

$minAIPilotID = 28;
$maxAIPilotID = 31;

   $actionStarted = false;
   $attackStarted = false;
   $guardAttacked = false;
   $lastScanner   = "";
   $spares        = 3;

   $objective = false;

   $navAlpha   = "MissionGroup/navPoints/navAlpha";
   $navBravo   = "MissionGroup/navPoints/navBravo";
   $navCharlie = "MissionGroup/navPoints/navCharlie";
   $navDelta   = "MissionGroup/navPoints/navDelta";

   $repairPath = "MissionGroup/RepairPath";
   $utilityPath = "MissionGroup/UtilityPath";
   $retreat     = "MissionGroup/UtilityRetreat";
   $truckspawn1 = getObjectID( "MissionGroup/RepairPath/marker1" );
   $truckspawn2 = getObjectID( "MissionGroup/UtilityRetreat/marker1" );
   $bridspawn   = getObjectID( "MissionGroup/BridLand/marker1" );

   newObject( "Guard", SimGroup );
   addToSet( "MissionGroup", "Guard" );
   newObject( "Repair", SimGroup );
   addToSet( "MissionGroup", "Repair" );
   newObject( "Utility", SimGroup );
   addToSet( "MissionGroup", "Utility" );
   newObject( "Brids1", SimGroup );
   addToSet( "MissionGroup", "Brids1" );
   newObject( "Brids2", SimGroup );
   addToSet( "MissionGroup", "Brids2" );
   newObject( "Brids3", SimGroup );
   addToSet( "MissionGroup", "Brids3" );
   newObject( "Brids4", SimGroup );
   addToSet( "MissionGroup", "Brids4" );
   newObject( "Brids5", SimGroup );
   addToSet( "MissionGroup", "Brids5" );
   newObject( "Bridship", SimGroup );
   addToSet( "MissionGroup", "Bridship" );

   $repair  = "MissionGroup/Repair";
   $utility = "MissionGroup/Utility";
   $brids1  = "MissionGroup/Brids1";
   $brids2  = "MissionGroup/Brids2";
   $brids3  = "MissionGroup/Brids3";
   $brids4  = "MissionGroup/Brids4";
   $brids5  = "MissionGroup/Brids5";

   $tracking = "MissionGroup/TrackStation";
   $base     = "MissionGroup/trooperBase";
   $turrets  = "MissionGroup/BaseTurrets";
   $Power    = getObjectID("MissionGroup/trooperBase/Power");
   $Track1   = getObjectID("MissionGroup/TrackStation/Trackbase");


   createTrucks();

   MPcheckBoundary( leave, getObjectID ($navCharlie) , 250, onLeaveNavCharlieWarning, 1 );
   MPcheckBoundary( leave, getObjectID ($navCharlie) , 450, onLeaveNavCharlie, 1 );
   MPcheckBoundary( enter, getObjectID ($navAlpha) , 100, onArriveNavAlpha, 1 );

   
}

//-----------------------------------------------------------------------------
function player::onAdd(%this)                                                                                                                        
{

say ( %this, 0, $Version @"\n"@ $textMsg );
say ( %this, 0,  "Check the game info tab for more details");
say ( %this, 0,  "<F5>Objective: Patrol all waypoints");

}

//-----------------------------------------------------------------------------
function vehicle::onAdd(%this)                                                                                                                        
{


// see if it is a player, if not exit
   %player = playerManager::vehicleIdToPlayerNum(%this);

   if (%player == 0) 
      return;


 messagebox (%player, "For sounds, copy CA0.vol from your CD (R click on CD, explore, data, sounds) & paste into main SS folder.");

say (%player, "Patrol the perimeter around our base.");
say (%player, "Check the game info tab for game details and objectives");

                                                                                   
   if (getTeam (%this) != *IDSTR_TEAM_YELLOW)
    {
     setTeam(%this, *IDSTR_TEAM_YELLOW);
     redrop(%this);
    }

 schedule( "setEnemyNavPoint(" @ %this @ ");", 3 );

 if ( $actionStarted == true )
   {
    if ( %player.state == "tked" )  
        {
   	%player.state = "";
        }
//      else
//       {
//        schedule ("healObject(" @ %this @ ", -50000);", 3);
//        Say(%player,0,"Sorry, you can't join until the next game.");
//       }
   }

}

//-----------------------------------------------------------------------------
function vehicle::onDestroyed(%this, %who)
{

// player dESTROYED 

   // give the death messages...
   %message = getFancyDeathMessage(getHUDName(%this), getHUDName(%who));
   if(%message != "")
   {
      say( 0, 0, %message);
   }


  if ( $actionStarted == true ) checkForPlayersDead();

// see if it is a player
   %player = playerManager::vehicleIdToPlayerNum(%this);
   if(%player == 0) 
   {
    schedule( "deleteObject(" @ %this @ ");", 1 );
    checkRedropSquad();
    

   }

   if (%this == $truck1)
    {
      redropTruck();
    }

   if ((%this != %who) &&
      (getTeam(%this) == getTeam(%who)) &&
      (getTeam(%this) == *IDSTR_TEAM_YELLOW))
    {
     %killerName = getHudName ( %who );
     %name = getHudName ( %this );

// Team kill, take action
     say(0,0,%killerName@" is being kicked for team-killing "@%name@".");
     say(%who, %who, "", "rules_violated.wav");
     %player = playerManager::vehicleIdToPlayerNum ( %who );
     kick ( %player, *IDMULT_CHAT_TEAM_KILL_KICK );

// allow TKed player to return
     say(%this, %this, "A teammate killed you. You may respawn.");
     %this.state = "tked";
    }
}

function vehicle::onScan(%scanned, %scanner)
{
   %who = playerManager::vehicleIdToPlayerNum(%scanner);

   if ( %scanned == $truck1 )
    {
      if (%scanner != $lastScanner)
       {
         // heals and reloads the scanner's vehicle
         
         order (%scanned, guard, %scanner);
         $lastScanner = %scanner;

         say (%who, 0, "REPAIR TRUCK: Acknowledged, sir.  Commencing repair and reload.");
         healObject (%scanner, 5000);
         reloadObject (%scanner, 5000);
       }
      else
       {
         order (%scanned, guard, $repairPath);
         say (%who, 0, "REPAIR TRUCK: Acknowledged, sir.  Returning to base.");
         $lastScanner = "";
       }
    }
}

function vehicle::onAttacked(%this, %who)
{
   if ((%this == $guard) && ($guardAttacked == false))
    {
      say (0,0, "PVT. RAINES: TAC-COM, this is Raines.  I'm under attack at Nav Alpha.  Hostiles are Cybrid!  Repeat: hostiles are Cybrid!");
      order ($utility, guard, $retreat);
      $guardAttacked = true;
    }
}

function structure::onDestroyed(%destroyed, %destroyer)
{
   if (%destroyed == $Power)
    {
      hum3talks( "CYB_GN46.wav" );
      say (0,0, "<f5>Defensive perimeter offline.");
      order ($turrets, shutdown, true);
    }
}

//-----------------------------------------------------------------------------
function pickPlayer ()
{

// 100 so we can be assured of getting a live player
   for (%p = 0; %p < 100; %p++)
     {
      %player = playerManager::getPlayerNum( randomInt( 0, playerManager::getPlayerCount() - 1 ) );

      %playerVeh = playerManager::playerNumToVehicleId( %player);

      if (( %playerVeh != "" ) &&
          (isGroupDestroyed (%playerVeh) == false))
       {
         return %playerVeh;
       }
     }
  return 0;
}

//-----------------------------------------------------------------------------
function onLeaveNavCharlie ()
{

cdAudioCycle( "NewTech", "Purge", "MechSoul");
dropShower();
order ($utility, guard, $utilityPath );
order ($guard, guard, $utility);
say (0,0, "TAC-COM: Utility crews are leaving for the tracking station.  We're still picking up some odd sensor echoes, so stay alert.");
schedule( "say ( 0,0, \"PVT. RAINES: Orbital Control, what's with this meteor shower?\", \"CA0_STP01.wav\" );", 5 );          //What's with meteor shower
schedule( "say ( 0,0, \"PVT. RAINES: Orbital Control?...  Damn solar flares...\", \"CA0_STP02.wav\" );", 14 );         // Orbital Control...damn solor flairs
schedule( "hum2Talks(\"GEN_ICCA03.wav\");", 27 );
schedule( "invasionTalk1();", randomInt(45,70) );
    
$actionStarted = true;


}

//-----------------------------------------------------------------------------
function onLeaveNavCharlieWarning ()
{
   say (0,0, "<f5>You are leaving the drop zone. By doing so you will start the mission.");
}

//-----------------------------------------------------------------------------
function setEnemyNavPoint( %this )
{
  setNavMarker( $navAlpha, true, %this );
}

//-----------------------------------------------------------------------------
function MPcheckBoundary( %dir, %obj2, %distance, %callback, %time )
{
// This is a modification of the campaign function "CheckBoundary"
//
// %dir  - enter or leave
// %obj2 - any object you want the players distance compared to
//         must be an ID (use getObjectid) and not a string ("MissionGroup/RedHerc/h1")
// %distance - if entering, they'd be within this range to run the function
//             if leaving, they'd be outside this range to run the function
// %callback - name of the function to run
// %time - when to reschedule the next check

  %jobRun = false;

   %playerCount = playerManager::getPlayerCount();

   for(%i=0; %i < %playerCount ; %i++)
     {
     %player = playerManager::getPlayerNum( %i );

     %obj1= playerManager::playerNumToVehicleId( %player);

   %var = getDistance( %obj1, %obj2 );

    if (%var != "0")
     {
     if( %dir == "enter" || %dir == "Enter" )
       {
        if( %var <= %distance )
          {
          if ( %jobRun == false )
            {
              %func = %callback @ "(" @ %obj1 @ ");";
              schedule( %func, 0 );
              %jobRun = true;
            }
          }
       }
    else if( %dir == "leave" || %dir == "Leave" )
      {
       if( %var >= %distance )
         {
          if ( %jobRun == false )
            {
              %func = %callback @ "();";
              schedule( %func, 0 );
              %jobRun = true;
            }
         }
      }
    }
  } // end for loop

  if  (%jobRun != true )
   {
   schedule( "MPcheckBoundary( "
             @ %dir @ ", "
             @ %obj2 @ ", "
             @ %distance @ ", "
             @ %callback @ ", "
             @ %time @ ");",
             %time );

   }

}


//-----------------------------------------------------------------------------
function pickPlayer ()
{

// 100 so we can be assured of getting a live player
   for (%p = 0; %p < 100; %p++)
     {
      %player = playerManager::getPlayerNum( randomInt( 0, playerManager::getPlayerCount() - 1 ) );

      %playerVeh = playerManager::playerNumToVehicleId( %player);

      if (( %playerVeh != "" ) &&
          (isGroupDestroyed (%playerVeh) == False))
       {
         return %playerVeh;
       }
     }
  return 0;
}

//-----------------------------------------------------------------------------
function countLivePlayers ()
{

  %count = 0;

   %playerCount = playerManager::getPlayerCount();

   for (%p = 0; %p < %playerCount; %p++)
     {
      %player = playerManager::getPlayerNum( %p );

      %playerVeh = playerManager::playerNumToVehicleId( %player);

      if (( %playerVeh != "" ) &&
          (isGroupDestroyed (%playerVeh) == False))
       {
         %count++;
       }
     }
  return %count;

}

//-----------------------------------------------------------------------------
function placeObject (%object, %x, %y, %rot)
{

  if ( %rot == "" ) %rot = 0;

  %z = getTerrainHeight(%x, %y);
  setPosition (%object, %x, %y, %z + 2, %rot);

}

//-----------------------------------------------------------------------------
function setNavBravoON()
{
   %playerCount = playerManager::getPlayerCount();

   for (%p = 0; %p < %playerCount; %p++)
     {
      %player = playerManager::getPlayerNum( %p );

      %playerVeh = playerManager::playerNumToVehicleId( %player);

      setNavMarker( $navBravo, true, %playerVeh  );
     }
}

//-----------------------------------------------------------------------------
function setNavCharlieON()
{
   %playerCount = playerManager::getPlayerCount();

   for (%p = 0; %p < %playerCount; %p++)
     {
      %player = playerManager::getPlayerNum( %p );

      %playerVeh = playerManager::playerNumToVehicleId( %player);

      setNavMarker( $navCharlie, true, %playerVeh  );
     }
}

//-----------------------------------------------------------------------------
function setNavDeltaON()
{
   %playerCount = playerManager::getPlayerCount();

   for (%p = 0; %p < %playerCount; %p++)
     {
      %player = playerManager::getPlayerNum( %p );

      %playerVeh = playerManager::playerNumToVehicleId( %player);

      setNavMarker( $navDelta, true, %playerVeh  );
     }
}

//-----------------------------------------------------------------------------
function checkForPlayersDead()
{
  %allDead = true;

   %playerCount = playerManager::getPlayerCount();

   for (%p = 0; %p < %playerCount; %p++)
     {
      %player = playerManager::getPlayerNum( %p );

      %playerVeh = playerManager::playerNumToVehicleId( %player);

      if (( %playerVeh != "" ) &&
          (isGroupDestroyed (%playerVeh) == False))
       {

         %allDead = False;
       }
     }

  if ( %allDead == true ) schedule ("missionFailed();", 3);

}

//-----------------------------------------------------------------------------
function missionFailed()
{
  flushConsoleScheduler();
  messageBox(0, "Mission Failed" );

  deleteObject("MissionGroup");
  deleteObject("MissionCleanup");
  deleteVariables($guardAttacked);
  deleteVariables($lastScanner);
  deleteVariables($spares);
  deleteVariables($objective);
  deleteVariables($navAlpha);
  deleteVariables($navBravo);
  deleteVariables($navCharlie);
  deleteVariables($navDelta);
  deleteVariables($repairPath);
  deleteVariables($utilityPath);
  deleteVariables($retreat);
  deleteVariables($truckspawn1);
  deleteVariables($truckspawn2);
  deleteVariables($bridspawn);
  deleteVariables($repair);
  deleteVariables($utility);
  deleteVariables($brids1);
  deleteVariables($brids2);
  deleteVariables($brids3);
  deleteVariables($brids4);
  deleteVariables($brids5);
  deleteVariables($tracking);
  deleteVariables($base);
  deleteVariables($turrets);
  deleteVariables($Power);
  deleteVariables($Track1);
  deleteVariables($truck1);
  deleteVariables($guard);
  
  // $MissionCycling::Stage0 = "c_moonpatrol";
  // $server::Mission = $MissionCycling::Stage0;
  missionEndConditionMet();
  // schedule("missionEndConditionMet();", 10);
  
}

//-----------------------------------------------------------------------------
function winCondition()
{
  flushConsoleScheduler();
  %howmany = 0;

  %text = "\nCybrid invasion repulsed: ";
  if ( $objective == true )
    {
     %howmany++;
     %text = %text @ "Successful";
    }
   else
    {
     %text = %text @ "Failed";
    }
  
  if ( %howmany == 1 ) %text = %text @ "\nExcellent work team.";

  messageBox(0, "Mission Completed, " @ %howmany @ " of 1 objectives completed. "@ %text );

  deleteObject("MissionGroup");
  deleteObject("MissionCleanup");
  deleteVariables($guardAttacked);
  deleteVariables($lastScanner);
  deleteVariables($spares);
  deleteVariables($objective);
  deleteVariables($navAlpha);
  deleteVariables($navBravo);
  deleteVariables($navCharlie);
  deleteVariables($navDelta);
  deleteVariables($repairPath);
  deleteVariables($utilityPath);
  deleteVariables($retreat);
  deleteVariables($truckspawn1);
  deleteVariables($truckspawn2);
  deleteVariables($bridspawn);
  deleteVariables($repair);
  deleteVariables($utility);
  deleteVariables($brids1);
  deleteVariables($brids2);
  deleteVariables($brids3);
  deleteVariables($brids4);
  deleteVariables($brids5);
  deleteVariables($tracking);
  deleteVariables($base);
  deleteVariables($turrets);
  deleteVariables($Power);
  deleteVariables($Track1);
  deleteVariables($truck1);
  deleteVariables($guard);

  // $MissionCycling::Stage0 = "c_moonpatrol";
  // $server::Mission = $MissionCycling::Stage0;
  missionEndConditionMet();
  // schedule("missionEndConditionMet();", 10);
}

// parts from CA0

// ------------------------------------------------------------------------------

function humTalks(%wav)
{
    playSound( 0, %wav, IDPRF_2D );
    
}
// ------------------------------------------------------------------------------

function hum2Talks( %wav)
{
    playSound( 0, %wav, IDPRF_2D );

}

// ------------------------------------------------------------------------------

function hum3Talks( %wav)
{
    playSound( 0, %wav, IDPRF_2D );

}

// ------------------------------------------------------------------------------

function invasionTalk1()
{
    hum2Talks( "CA0_WST01.wav" );                              // Movement at impact sites
    schedule( "hum3Talks( \"CYB_ME02.wav\" ); ", 3 );         //movement hotside
    schedule( "hum2Talks( \"CA0_STP03.wav\" );", 5 );         // Copy West
    schedule( "hum2Talks( \"CA0_BLU01.wav\" );", 10 );         // Unidentified signals
    schedule( "hum2Talks( \"CA0_STP04.wav\" );", 13 );         // Confirm, Blue
    schedule( "hum2Talks( \"CA0_WST02.wav\" );", 25 );         // Got movement, investigating
    schedule( "hum2Talks( \"CA0_BLU02.wav\" );", 45 );         // They're hostile
    schedule( "hum2Talks( \"CA0_STP05.wav\" );", 48 );         // Rebels?
    schedule( "invasionTalk2();", 50 );
}

// ------------------------------------------------------------------------------

function invasionTalk2()
{                                                                 
    hum2Talks( "CA0_BLU03.wav" );                              // Not rebs, outnumbered
    schedule( "hum2Talks( \"CA0_WST03.wav\" );", 5 );         // West here, under fire
    schedule( "hum2Talks( \"CA0_BLU04.wav\" );", 10 );         // Getting a better look...
    schedule( "hum2Talks( \"CA0_STP06.wav\" );", 13 );         // All units scramble
    schedule( "hum2Talks( \"CA0_WST04.wav\" );", 15 );         // Green Patrol offline
    schedule( "hum2Talks( \"CA0_BLU05.wav\" );", 20 );         // Christ and Hunter
    schedule( "hum2Talks( \"CA0_STP07.wav\" );", 23 );         // talk to me, blue
    schedule( "hum2Talks( \"CA0_BLU06.wav\" );", 25 );         // Cybrids!
    schedule( "hum2Talks( \"CA0_BLU07.wav\" );", 26 );         // death-cry
    schedule( "hum3Talks( \"CYB_GN53.wav\" );", 30 );         // sectors going out
    schedule( "hum3Talks( \"CYB_ME10.wav\" );", 33 );         // tac-com, help, please
    schedule( "invasionTalk3();", 35 );         
}
                            
// ------------------------------------------------------------------------------

function invasionTalk3()
{
    hum2Talks( "CA0_WST06.wav" );                                 // perimeter breach
    schedule( "hum3Talks( \"CYB_GN47.wav\" );", 5 );         // sectors going out
    schedule( "hum2Talks( \"CA0_WST05.wav\" );", 10 );         // Where's the navy
    schedule( "hum3Talks( \"CYB_GN55.wav\" );", 12 );         // sectors going out
    schedule( "hum2Talks( \"CA0_WST07.wav\" );", 15 );         // death-cry
    schedule( "hum3Talks( \"CYB_GN50.wav\" );", 18 );         // sectors going out
    schedule( "hum2Talks( \"CA0_STP08.wav\" );", 21 );         // blue? transfer commlinks
    schedule( "hum3Talks( \"CYB_GN54.wav\" );", 25 );            // sectors going out
    schedule( "hum3Talks( \"CYB_ME19.wav\" );", 30 );         // They're on the perimeter
    schedule( "hum3Talks( \"CYB_ME13.wav\" );", 35 );         // glitches everywhere
    schedule( "hum3Talks( \"CYB_GN52.wav\" );", 50 );         // sectors going out
    schedule( "hum2Talks( \"CYB_GN48.wav\" );", 70 );            // sectors going out
    schedule( "hum2Talks(\"CYB_ME22.wav\" );", 80 );         // glitches zapped coolent reserve
    schedule( "hum2Talks( \"CYB_GN46.wav\" );", 95 );         // sectors going out
    schedule( "hum2Talks(\"CYB_GN49.wav\" );", 120 );            // sectors going out
    schedule( "hum2Talks( \"CYB_GN51.wav\" );", 150 );           // sectors going out
    schedule( "hum2Talks( \"CYB_GN57.wav\" );", 165 );         // emergency crews responding
    schedule( "hum2Talks( \"CYB_GN56.wav\" );", 190 );           // sectors going out    
}

// ---------------------------------------------------------------------------------

function createTrucks()
{
   %x = getPosition( $truckspawn1, x );
   %y = getPosition( $truckspawn1, y );

   %herc = newObject( "Repair", Tank, 71);
   setTeam ( %herc, *IDSTR_TEAM_YELLOW );

   addToSet( $repair, %herc );
   placeObject ( %herc, %x, %y, 180 );
   $truck1 = %herc;

   %x = getPosition( $truckspawn2, x );
   %y = getPosition( $truckspawn2, y );

   %herc = newObject( "Utility", Tank, 71);
   setTeam ( %herc, *IDSTR_TEAM_YELLOW );

   addToSet( $utility, %herc );
   placeObject ( %herc, %x, %y, 180 );

   %x = %x + 10;

   %herc = newObject( "Talon", Herc, 4 );
   setTeam ( %herc, *IDSTR_TEAM_YELLOW );
   setPilotID ( %herc, 32 );
   
   addToSet( "MissionGroup/Guard", %herc );
   placeObject ( %herc, %x, %y, 180);
   $guard = %herc;
   
}

function onArriveNavAlpha()
{
   say (0,0, "TAC-COM: Patrol, we're picking up movement north of our listening posts at Nav Bravo.  Go in and investigate.  You are authorized to fire if fired upon.");
   schedule ( "setNavBravoON();", 5 );
   schedule ( "say (0,0, \"TAC-COM: Getting strange reports of impacts all across this hemisphere.  What is going on?\");", 8);
   schedule( "createBrids1();", 4);
   schedule( "createBrids2();", randomInt(45, 60) );
}

function createBrids1()
{
   %howMany = countLivePlayers();
   if (%howMany > 4) $howMany = $howMany - 2;

   %x = 2200;
   %y = 1200;

   for ( %i = 0; %i < %howMany ; %i++ )
    {

//if ( %i > 10 ) break;

     %name = "Cybrid"@ %i;
     %r = randomInt (1, 3);

   if (%r == 3)
    {
     %herc = NewObject( %name, Herc, 22);
    }
   else
    {
     %herc = NewObject( %name, Herc, 21);
    }
   

     setTeam (%herc, *IDSTR_TEAM_RED);
     %pilotID = randomInt ( $minAIPilotID, $maxAIPilotID );
     setPilotId (%herc, %pilotID);

     addToSet( $brids1, %herc ); 

     placeObject(%herc, %x, %y, 180);

     %x = %x + 10;

    }
   
   order ($brids1, attack, $tracking);
}

function createBrids2()
{
   %howMany = countLivePlayers();
   if (%howMany > 2) $howMany = $howMany - 2;

   %x = 1800;
   %y = -1000;

   for ( %i = 0; %i < %howMany ; %i++ )
    {

//if ( %i > 10 ) break;

     %name = "Cybrid"@ %i;
     %r = randomInt (1, 3);

   if (%r == 3)
    {
     %herc = NewObject( %name, Herc, 22);
    }
   else
    {
     %herc = NewObject( %name, Herc, 21);
    }
   

     setTeam (%herc, *IDSTR_TEAM_RED);
     %pilotID = randomInt ( $minAIPilotID, $maxAIPilotID );
     setPilotId (%herc, %pilotID);

     addToSet( $brids2, %herc ); 

     placeObject(%herc, %x, %y);

     %x = %x + 10;

    }
   
   order ($brids2, attack, $tracking);
   schedule ( "createBrids3();", 150);
}

function createBrids3()
{
   say (0,0, "TAC-COM: We've got multiple signals on an attack vector for the base.  All units intercept and destroy the invaders.");
   order ($guard, guard, $base);
   setNavCharlieON();
   schedule ( "say (0,0, \"TAC-COM: Sim-Tac, this is Forward Command Sector 6.  We are under attack, requesting support...  Sim-Tac?... Damn!  The tin cans are jamming us.\");", 8 );
   schedule ( "say (0,0, \"TAC-COM: Patrol, we're detecting what appears to be a large vessel at Nav Delta.  Looks like it's the source of the jammer.  We need to take it out if we're to call for help.\");", 16);
   MPcheckBoundary( enter, getObjectID ($navCharlie) , 150, onArriveNavCharlie, 1 );

   %howMany = countLivePlayers() + 2;
  

   %x = -500;
   %y = 1400;

   for ( %i = 0; %i < %howMany ; %i++ )
    {

//if ( %i > 10 ) break;

     %name = "Cybrid"@ %i;
     %r = randomInt (20, 23);

     %herc = NewObject( %name, Herc, %r);

     setTeam (%herc, *IDSTR_TEAM_RED);
     %pilotID = randomInt ( $minAIPilotID, $maxAIPilotID );
     setPilotId (%herc, %pilotID);

     addToSet( $brids3, %herc ); 

     placeObject(%herc, %x, %y);

     %x = %x + 10;

    }
   
   order ($brids3, attack, $base);
   schedule ( "createBrids4();", 65);
   createBrids5();
}

function createBrids4()
{
   %howMany = countLivePlayers();
   if (%howMany > 4) $howMany = 4;

   %x = -1300;
   %y = -100;

   for ( %i = 0; %i < %howMany ; %i++ )
    {

//if ( %i > 10 ) break;

     %name = "Cybrid"@ %i;
     %r = randomInt (1, 3);

   if (%r == 3)
    {
     %herc = NewObject( %name, Herc, 23);
    }
   else
    {
     %herc = NewObject( %name, Herc, 22);
    }
   

     setTeam (%herc, *IDSTR_TEAM_RED);
     %pilotID = randomInt ( $minAIPilotID, $maxAIPilotID );
     setPilotId (%herc, %pilotID);

     addToSet( $brids4, %herc ); 

     placeObject(%herc, %x, %y);

     %y = %y + 10;

    }
   
   order ($brids4, attack, $Power);
}

function createBrids5()
{
   %howMany = countLivePlayers();
   if (%howMany > 4) $howMany = 4;

   %x = getPosition( $bridspawn, x );
   %y = getPosition( $bridspawn, y );

   %herc = newObject ( "Emissary", Flyer, 92 );
   setTeam ( %herc, *IDSTR_TEAM_RED );
   addToSet ( "MissionGroup/Bridship", %herc );
   placeObject ( %herc, %x, %y, 180 );
   order ( %herc, shutdown, true );
   $ship = %herc;

   %y = %y + 75;

   for ( %i = 0; %i < %howMany ; %i++ )
    {

//if ( %i > 10 ) break;

     %name = "Cybrid"@ %i;
     %r = randomInt (1, 3);

   if (%r == 3)
    {
     %herc = NewObject( %name, Tank, 25);
    }
   else
    {
     %herc = NewObject( %name, Herc, 24);
    }
   

     setTeam (%herc, *IDSTR_TEAM_RED);
     %pilotID = randomInt ( $minAIPilotID, $maxAIPilotID );
     setPilotId (%herc, %pilotID);

     addToSet( $brids5, %herc ); 

     placeObject(%herc, %x, %y, 180);

     %x = %x + 20;

    }
   
   order ($brids5, guard, $ship);
   checkBridsDead();
}


function dropShower()
{
   %num = randomInt(1,10);
   if (%num == 1)
    {
      schedule ("dropPod( 1550, 2900, getTerrainHeight(1550, 2900) + 1000, 1550, 2900, getTerrainHeight(1550, 2900));", randomInt(1,20));
    }
   if (%num == 2)
    {
      schedule ("dropPod( -1550, 3300, getTerrainHeight(-1550, 3300) + 1000, -1550, 3300, getTerrainHeight(-1550, 3300));", randomInt(1,20));
    }
   if (%num == 3)
    {
      schedule ("dropPod( 470, -1800, getTerrainHeight(470, -1800) + 1000, 470, -1800, getTerrainHeight(470, -1800));", randomInt(1,20));
    }
   if (%num == 4)
    {
      schedule ("dropPod( 2220, 2900, getTerrainHeight(2220, 2900) + 1000, 2220, 2900, getTerrainHeight(2220, 2900));", randomInt(1,20));
    }
   if (%num == 5)
    {
      schedule ("dropPod( -300, 2600, getTerrainHeight(-300, 2600) + 1000, -300, 2600, getTerrainHeight(-300, 2600));", randomInt(1,20));
    }
   if (%num == 6)
    {
      schedule ("dropPod( 1950, -1900, getTerrainHeight(1950, -1900) + 1000, 1950, -1900, getTerrainHeight(1950, -1900));", randomInt(1,20));
    }
   if (%num == 7)
    {
      schedule ("dropPod( -2200, 100, getTerrainHeight(-2200, 100) + 1000, -2200, 100, getTerrainHeight(-2200, 100));", randomInt(1,20));
    }
   if (%num == 8)
    {
      schedule ("dropPod( 2750, -500, getTerrainHeight(2750, -500) + 1000, 2750, -500, getTerrainHeight(2750, -500));", randomInt(1,20));
    }
   if (%num == 9)
    {
      schedule ("dropPod( -1100, -1700, getTerrainHeight(-1100, -1700) + 1000, -1100, -1700, getTerrainHeight(-1100, -1700));", randomInt(1,20));
    }
   if (%num == 10)
    {
      schedule ("dropPod( -670, 2900, getTerrainHeight(-670, 2900) + 1000, -670, 2900, getTerrainHeight(-670, 2900));", randomInt(1,20));
    }
   schedule ("dropShower();", 3);

}

function redropTruck()
{
   if ($spares > 0)
    {
      say (0,0, "<f5>Repair truck destroyed.  Spare truck waiting at base.");
      %x = getPosition( $truckspawn1, x );
      %y = getPosition( $truckspawn1, y );

      %herc = newObject( "Repair", Tank, 71);
      setTeam ( %herc, *IDSTR_TEAM_YELLOW );

      addToSet( $repair, %herc );
      placeObject ( %herc, %x, %y, 180 );
      $truck1 = %herc;  
      $spares--;

    }
}

function checkBridsDead()
{
    %deadBrids = 0;
    if ( isGroupDestroyed ($brids1) == true ) %deadBrids++;
    if ( isGroupDestroyed ($brids2) == true ) %deadBrids++;
    if ( isGroupDestroyed ($brids3) == true ) %deadBrids++;
    if ( isGroupDestroyed ($brids4) == true ) %deadBrids++;
    if ( isGroupDestroyed ($brids5) == true ) %deadBrids++;
    
    if ( %deadBrids > 4 )
     {
       say (0,0, "TAC-COM: We confirm destruction of the Cybrid force.  Good work, people.  Now get back to base for repairs.  Judging from the reports we've been getting from the other sectors, it looks like the toasters got the drop on us.  It's going to be one heck of a fight...");
       schedule( "say( 0, 0, \"GEN_OC01.wav\" );", 2 );
       $objective = true;
       
       schedule ( "winCondition();", 5);
     }
    else
     {
       schedule ( "checkBridsDead();", 5 );
     }
}

function onArriveNavCharlie()
{
   setNavDeltaON();
}